#include "stdafx.h"
#include "targetver.h"

#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include <process.h>
#include "dx/dx_control.h"			// DirectX T|[g
#include "dx/dx_sound.h"			// DirectSound T|[g
#include "glb/glbDefine.h"	// [NfobO֐錾
#include "glb/SingletonCtrl.h"	// [NfobO֐錾
#include "TestExec.h"
#include "io/dxEventIO.h"

using namespace dx;


// o͊Ǘ
static dxEventIO *s_pEventIO = null;


// `vV[W
void RenderProc( IDirect3DDevice9 *pDevice, void *pvData )
{
	teProc();
}


// bZ[WvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	// PlaneRunner͏
	if ( s_pEventIO != null )
	{
		if ( s_pEventIO->WinProc( hWnd, message, wParam, lParam ) )
			return 0;
	}

	switch (message)
	{
	case WM_SIZE:
		{
			// Window̃TCY
			SIZE s;
			s.cx = LOWORD(lParam);
			s.cy = HIWORD(lParam);
			dx_control::Instance().Screen( s );
		}
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}


// C
int APIENTRY _tWinMain(HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPTSTR    lpCmdLine,
					   int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);


	WNDCLASSEX wcex = {0};
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.hInstance		= hInstance;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszClassName	= TEXT("PR_WINDOW");
	RegisterClassEx(&wcex);


	// O[oϐɃCX^Xi[܂B
	HWND hWnd = CreateWindow(
						TEXT("PR_WINDOW"), 
						TEXT("PlaneRunner Test"), 
						WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT, 
						0, 
						CW_USEDEFAULT, 
						0, 
						NULL, NULL, 
						hInstance, NULL );

	if ( !hWnd ) return FALSE;

	dx_control::Instance().Init( hWnd, TRUE );
	dx_sound::Instance().Init( hWnd );

	ShowWindow(hWnd, nCmdShow);
	// WM_PAINTĂ΂Ȃ悤ɂ
	::ValidateRect(hWnd, 0);
	UpdateWindow(hWnd);

	// 
	s_pEventIO = teInit();


	MSG msg;
	ZeroMemory( &msg, sizeof(msg) );

	while ( msg.message != WM_QUIT )
	{
		if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else
		{
			dx_control::Instance().Render( RenderProc, NULL );
		}
	}

	// ȊOɓ͂؂Ă
	s_pEventIO = null;
	// I
	teTerm();

	dx_sound::Instance().Dispose();
	dx_control::Instance().Dispose();

	// VOg̉s
	SlDeleteAll();

	// ݂̊mے̃WvđSĕ\
	OutputDbMemInfo();

	return (int) msg.wParam;
}


