#ifndef INCLUDE_BMP_CONTROL_H
#define INCLUDE_BMP_CONTROL_H
#include <windows.h>

// sNZC[W\
struct bmp_color
{
	BYTE	b;
	BYTE	g;
	BYTE	r;
	BYTE	a;
};


// bmpNX
class bmp_control
{
private:
	HDC		hDC;
	HDC		hMDC;
	HBITMAP hTmpBMP;
	SIZE	sImageSize;
	BYTE	*pImage;

public:
	// RXgN^
	bmp_control( HWND hWnd, const SIZE *pSize );
	virtual ~bmp_control();

	// C[WpfoCXReLXg擾
	HDC MemDC() const { return this->hMDC; }

	const SIZE *Size() const { return &this->sImageSize; }

	// rbg}bv擾
	void GetBmpInfo( BITMAP *pOutBmp ) const;

	// rbg}bvۑ
	void Save( const char *pcName );

	// SẴsNZɑ΂đ
	typedef  void (PixControlFunc)( int, int, bmp_color *);
	void PixControl( PixControlFunc *pFunc );

	// Cӂ̃sNZf[^擾
	bmp_color *GetPixel( int iX, int iY );
	bmp_color *GetPixel( int iIndex );

	// C[WCӂ̐FœhԂ
	void ClearImage( const bmp_color *pColor );


	// bmp̃C[WCӂ̏ꏊɕ`
	void BitBlt( HDC hOut, const RECT *pOutRect, const POINT *pSrcPos );
	void BitBlt( HDC hOut, const POINT *pDistPos );
};

#endif // INCLUDE_BMP_CONTROL_H