#ifndef INCLUDE_DX_SPRITE_H
#define INCLUDE_DX_SPRITE_H
#include <d3dx9.h>
#include <d3d9types.h>
#include <windows.h>


//2D|S(_obt@)
class dx_sprite
{
	LPDIRECT3DVERTEXBUFFER9	pVB;
	bool bUpdate;
	D3DXVECTOR2 sUV;
	D3DXVECTOR2 sSize;
	
public:
	// RXgN^
	dx_sprite()
		: pVB( NULL )
		, sUV( 0.0f, 0.0f )
		, sSize( 50.0f, 50.0f )
		, bUpdate( false )
	{
	}

	// fXgN^
	~dx_sprite(){};
	
	// eNX`ݒ
	void SetTexture();


	//UVݒ
	void SetUV( const D3DXVECTOR2 *pUV );

	//TCYݒ
	void SetSize( const D3DXVECTOR2 *pSize );

	// (_obt@̍쐬)
	bool Init();

	// `
	bool Draw( const D3DXMATRIX *pmParent, D3DCOLOR Color );

private:
	bool Update();
};

#endif // INCLUDE_DX_SPRITE_H
