#include "stdafx.h"
#include "glb/glbDefine.h"
#include "glb/glbDebug.h"
#include "glb/glbString.h"
#include "dxFile.h"

using namespace glb;
namespace dx
{
	// RXgN^
	dxFile::dxFile( const glb::glbString *pFileName )
	{
		// ubN[h
		est::ifstream f;

		const est::vector<unsigned char> &rBuffer = pFileName->Buffer();
		switch( pFileName->Format() )
		{
			case seTextFormat::Shift_Jis:
				f.open((const char *)&rBuffer[ 0 ], est::ios::in | est::ios::binary );
				break;
			case seTextFormat::Utf16:
				f.open((const wchar_t*)&rBuffer[ 0 ], est::ios::in | est::ios::binary );
				break;
		}

		GLB_ASSERT( f.is_open() != 0 );
		f.seekg(0, std::ios::end );
		est::streamsize size = f.tellg();
		f.seekg(0, std::ios::beg );

		this->stvBuffer.resize( size );
		f.read( (char*)(&this->stvBuffer[ 0 ]), size );
		f.close();
	}


	// t@C[hIۂ
	// t@C[hIAsiFile.Bufferf[^ɃANZX
	// łԂɂȂtrue,ȊOfalseԂĂB
	// 
	// @retval : true [hI  false [hor[h
	bool dxFile::IsLoadFinish()
	{

		return true;
	}

	// [ht@Cf[^擾
	const est::vector<glb::Byte> *dxFile::Buffer()
	{
		return &this->stvBuffer;
	}

	// [hԍXVLqĉB
	// siFilenewĂIsLoadFinishtrueԂ܂
	// t[Ăяo܂BKvȂꍇ͋ɂĒuĂB
	void dxFile::Update()
	{

	}

}
