#ifndef INCLUDE_DXOBJECTFONTSTYLE_H
#define INCLUDE_DXOBJECTFONTSTYLE_H
#include "glb/glbDefine.h"
#include "evc/seObject/ObjectParts/seoFont/seFontData.h"


class font_control;

using namespace evc;
using namespace glb;
namespace dx
{
	// tHgX^CǗ
	class dxObjectFontStyle
	{
	private:
		glb::glbString		strFontName;
		float				fHeight;
		seFontStyle::Type	eStyle;
		font_control		*pFont;

	public:
		seFontStyle::Type Style() const	{ return eStyle; }
		// tHg̍擾Eݒ
		float Height() const		{ return fHeight; }
		// tHg̎擾Eݒ
		const glb::glbString *FontName() const		{ return &this->strFontName; }

		font_control *Font() const	{ return this->pFont; }


		bool IsSameData( dxObjectFontStyle *pStyle );

		void Dispose();

		// RXgN^
		dxObjectFontStyle ( const glb::glbString *strFontName, float fHeight, seFontStyle::Type eStyle );
		virtual ~dxObjectFontStyle();
	};



	// tHgX^CǗ
	class dxObjectFontStyleManager
	{
	private:
		// tHgX^CXg
		est::vector<dxObjectFontStyle*>	lisStyle;

	public:
		dxObjectFontStyleManager();
		virtual ~dxObjectFontStyleManager();

		// X^C
		dxObjectFontStyle *Find( int iIndex );

		// @retval ID
		int Create( const glb::glbString *strFontName, float fHeight, seFontStyle::Type Style );

		void Clear();
	};
}

#endif // INCLUDE_DXOBJECTFONTSTYLE_H