#ifndef INCLUDE_NNOBJECT_H
#define INCLUDE_NNOBJECT_H
#include "evc/IO/siObject.h"

using namespace glb;
using namespace evc;

namespace nn
{
	// J[XvCg`Ǘ
	class nnObjectColorSprite : public siObjectColorSprite
	{
	public:
		// TCYXVꂽ
		virtual void UpdateSize(const glbVector2 *pSize ){}

		// `v
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor){}
	};


	// eNX`XvCg`Ǘ
	class nnObjectTextureSprite : public siObjectTextureSprite
	{
	public:
		// eNX`XVꂽ
		virtual void UpdateTexture( siResourceTexture *pTextrue ){}
		// TCYXVꂽ
		virtual void UpdateSize( const glbVector2 *pSize ){}
		// UVXVꂽ
		virtual void UpdateUV( const glbVector2 *pUV){}

		// `v
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor){}
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor, const IGLMatrix *pmUV){}

	};



	// bVǗ
	class nnObjectMesh : public siObjectMesh
	{
	public:
		// eNX`XVꂽ
		virtual void UpdateTexture( siResourceTexture *pTexture ){}
		// `v
		virtual void Draw( int iElemID, const IGLMatrix *m, const glbColor *pColor, const IGLMatrix *mUV){}
		// 
		virtual void Dispose(){}

		// _̕ҏWJnAI錾
		virtual void BeginEditVertex( int iElemID ){}
		virtual void EndEditVertex(){}
		// _̐VʒuAUVWݒ肵܂B
		virtual void SetPos( int iIndex, const glbVector2 *pos ){}
		virtual void SetUV( int iIndex, const glbVector2 *uv ){}

		// VIndex̔zݒ肵܂B
		virtual void SetIndex( const est::vector<short> &id ){}
	};




	// TEhǗ
	class nnObjectSound : public siObjectSound
	{
	public:
		// pXVꂽ
		virtual void UpdatePan(int value ){}
		// {[XVꂽ
		virtual void UpdateVolume(int value ){}

		// Đv
		virtual void Play(int iElemID, float fStart, bool bLoop){}
		virtual void Play(int iElemID, float fStart, float fTime, bool bLoop){}

		// ~v
		virtual void Stop(){}

		// fobOp`
		virtual void Draw( const IGLMatrix *pmParent, int iElemID, int iDmy){}
	};
}
#endif // INCLUDE_NNOBJECT_H
