#ifndef INCLUDE_NNIOMANAGER_H
#define INCLUDE_NNIOMANAGER_H
#include "evc/IO/siIOManager.h"
#include "nnEventIO.h"
#include "nnMaterial.h"
#include "nnMatrix.h"
#include "nnFile.h"
#include "nnObject.h"
#include "nnObjectFont.h"
#include "nnResource.h"

using namespace glb;
using namespace evc;

namespace nn
{
	// o͊Ǘ
	class nnIOManager : public siIOManager
	{
	public:

		// }gNX쐬
		virtual IGLMatrix *CreateMatrix() { return evc_new nnMatrix(); }

		// Pt@C[hǗ쐬
		// @param strPath		 : [hvt@C̃pX
		// @param pSceneManager : vt@CV[(null=[gV[)
		virtual siFile *CreateLoader( seSceneManager *pinScManager, const glb::glbString *pstrPath )
		{
			return evc_new nnFile( pstrPath );
		}


		// IuWFNg쐬֌W
		// 

		// J[XvCg̍쐬vꂽɌĂяo܂B
		virtual siObjectColorSprite *CreateColorSprite( int iElemID )
		{
			return evc_new nnObjectColorSprite();
		}

		// eNX`XvCg̍쐬vꂽɌĂяo܂B
		virtual siObjectTextureSprite *CreateTextureSprite( int iElemID )
		{
			return evc_new nnObjectTextureSprite();
		}


		// TEh̍쐬vꂽɌĂяo܂B
		virtual siObjectSound *CreateSound(int iElemID, siResourceSound *pSound )
		{
			return evc_new nnObjectSound();
		}

		//! bV`Ǘ쐬
		virtual siObjectMesh *CreateMesh( int iElemID, int iVertexCount, int iIndexCount )
		{
			return evc_new nnObjectMesh();
		}


		// `Ǘ쐬
		virtual siObjectFont *CreateObjectFont( int iElemID )
		{
			return evc_new nnObjectFont();
		}





		// \[X쐬֌W
		//

		// eNX`\[X쐬ɌĂяo܂B
		// @parama strName:̓t@CpX
		// @retval null:s  !null:
		virtual siResourceTexture *CraeteTextureResource(
							seSceneManager *pSceneManager, 
							const glb::glbString *pstrPath,
							const glbVector2I *pTextureSize )
		{
			return evc_new nnResourceTexture( pstrPath );
		}


		// TEh̃\[X쐬ɌĂяo܂B
		// @parama strName:̓t@CpX
		// @retval null:s  !null:
		virtual siResourceSound *CraeteSoundResource(
							seSceneManager *pSceneManager,
							const glb::glbString *pstrPath )
		{
			return evc_new nnResourceSound( pstrPath );
		}



		// }XN֌W
		//

		// V}XNo^
		// }XN`悪Ă΂钼OɐV}XN̑S̗̈\}gNXƂ
		// ̃\bhĂ΂܂B
		// RegisterMask͐V}XNݒ肷xɌĂ΂܂B
		virtual void RegisterMask( const IGLMatrix *pm, const glbVector2 *pSize ){}

		// }XN̏Iʒm܂B
		// [U}XNIݒvf`悵ɌĂ΂܂B
		virtual void ClearMask(){}



		// fobOpo
		virtual void DebugString(const glb::glbString *pstrMsg ){}


		// 
		virtual ~nnIOManager(){}
	};
}
#endif // INCLUDE_NNIOMANAGER_H
