#ifndef INCLUDE_NNRESOURCE_H
#define INCLUDE_NNRESOURCE_H
#include "evc/IO/siResource.h"

using namespace glb;
using namespace evc;

namespace nn
{
	// TEh\[X
	class nnResourceSound : public siResourceSound
	{
	public:
		nnResourceSound( const glb::glbString *pcName )
			: siResourceSound( pcName ){}

		// \[X̏
		virtual siResourceInit::Type Init( const est::vector<glb::Byte> *buffer ){ return siResourceInit::Success;}

		virtual ~nnResourceSound(){}
	};


	// eNX`\[X
	class nnResourceTexture : public siResourceTexture
	{
	private:
		glb::glbVector2I		sTexSize;
	public:
		// RXgN^
		nnResourceTexture( const glb::glbString *pcName )
			:siResourceTexture( pcName )
			,sTexSize( 0, 0 ){}

		// \[X̏
		virtual siResourceInit::Type Init( const est::vector<glb::Byte> *buffer ) { return siResourceInit::Success; }

		// 蔻
		virtual bool IsHit( const glbVector2I *pHitPos ){ return true; }

		// eNX`TCY:
		// eNX`̕AԂĉB
		virtual const glbVector2I *TextureSize() { return &this->sTexSize; }
	};
}
#endif // INCLUDE_SIRESOURCE_H
