#ifndef INCLUDE_TSFILE_H
#define INCLUDE_TSFILE_H
#include "evc/IO/siFile.h"

using namespace evc;
// Pt@C͊Ǘ
class tsFile : public siFile
{
public:

	// RXgN^
	tsFile( const glb::glbString *pFileName )
	{
		est::ifstream f;
		f.open((char*)(&pFileName->Buffer()[0]), est::ios::in | est::ios::binary );
		assert( f.is_open() != 0 );

		f.seekg(0, est::ios::end );
		est::streamsize size = f.tellg();
		f.seekg(0, est::ios::beg );

		this->stvBuffer.resize( size );
		f.read( (char*)(&this->stvBuffer[ 0 ]), size );
		f.close();
	}
	
	// t@C[hIۂ
	virtual bool IsLoadFinish(){ return true; }

	// [ht@Cf[^擾
	virtual const est::vector<glb::Byte> *Buffer()
	{
		return &this->stvBuffer; 
	}

	virtual void Update(){}
	virtual ~tsFile(){}
};
#endif // INCLUDE_TSFILE_H


