/**
 * @file FpAnimHermite.h
 * @brief 
 *
 * @author seri
 */
#ifndef FPANIMHERMITE_H
#define FPANIMHERMITE_H
#pragma once
#include "../FePointInfo.h"

using namespace glb;
namespace evc
{
	class IseStateInput;

	/** 
	 * @brief G~[g(Đp)
	 */
	class FpAnimHermite : public IFeAnimBase
	{
	private:
		glbVector2 sBefoPower;
		glbVector2 sPower;

	public:
		const glbVector2 *BefoPower() const { return &this->sBefoPower; }
		void BefoPower( const glbVector2 *value) { this->sBefoPower = *value; }

		const glbVector2 *Power() const { return &this->sPower; }
		void Power( const glbVector2 *value) { this->sPower = *value; }

		FpAnimHermite(){}
		virtual ~FpAnimHermite(){}

		// t[(0.0f`1.0f)ɑ΂isx擾
		float GetFramePos(float fAnimFrame, 
						const FePointInfo *pBefoInfo, 
						const FePointInfo *pNowInfo);

		// t@C[h
		void Load(IseStateInput *pInput);
	};

}
#endif //FPANIMHERMITE_H

