#include "glbPch.h"
#include "FpAnimSaw.h"
#include "evc/file/IseStateIO.h"

using namespace glb;
namespace evc
{
	// RXgN^
	FpAnimSaw::FpAnimSaw()
		: fNum( 0.0f )
		, fScale( 0.0f )
	{

	}


	float FpAnimSaw::GetFramePos(float fAnimFrame, const FePointInfo *pBefoInfo, const FePointInfo *pNowInfo)
	{
		float fSawNum = this->Num() * 30.0f; // ̂̎̐
		float fSawScale = this->Scale() * 1.5f; // ̂̎̍
	
		float fBfoRate = pBefoInfo->Rate();
		float fRate = (fAnimFrame - fBfoRate) / (pNowInfo->Rate() - fBfoRate);
	
		// ̂̎̐獡̍Zo
		float fSaw = fRate * fSawNum;
		// 1.0fŊ܂Zo
		fSaw -= static_cast<float>(static_cast<int>(fSaw));
		// ̍B
		fSaw *= fSawScale;
	
		float fBfoValue = pBefoInfo->Value();
		return ((pNowInfo->Value() - fBfoValue) * fRate + fBfoValue) + fSaw;
	}

	void FpAnimSaw::Load(IseStateInput *pInput)
	{
		this->fNum = pInput->ReadFloat();
		this->fScale = pInput->ReadFloat();
	}
}
