/**
 * @file siIOManager.h
 * @brief o͊Ǘ
 *
 * @author seri
 */
#ifndef INCLUDE_SIIOMANAGER_H
#define INCLUDE_SIIOMANAGER_H
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "evc/IO/siObject.h"


using namespace glb;

namespace evc
{
	class seSceneManager;
	class siEventIO;
	class siMaterial;
	class siFile;
	class siObjectColorSprite;
	class siObjectTextureSprite;
	class siObjectSound;
	class siObjectFont;
	class siResourceTexture;
	class siResourceSound;
	class siObjectMesh;

	/** o͊Ǘ
	 * @brief foCXւ̏óA͂Ǘ܂B
	 * SĂ̓o͂͂̃NXʂčs܂B
	 */
	class siIOManager
	{
	public:

		/** 
		 * @brief }gNX쐬
		 * @return V}gNXNX쐬ĉB
		 */
		virtual IGLMatrix *CreateMatrix() = 0;

		/** Pt@C[hǗ쐬
		 * @brief Vt@C[hNX쐬ĉB
		 * @param pinScManager vt@CV[(null=[gV[)
		 * @param pstrPath [hvt@C̃pX
		 * @return 
		 */
		virtual siFile *CreateLoader( seSceneManager *pinScManager, const glb::glbString *pstrPath ) = 0;


		// IuWFNg쐬֌W
		// 

		/** 
		 * @brief J[XvCg̍쐬vꂽɌĂяo܂B
		 * VJ[XvCg쐬ĉB
		 * @param iElemID 쐬ꂽJ[XvCggpGg̎ID
		 * @param pSize XvCg̃TCY
		 * @return J[XvCg
		 */
		virtual siObjectColorSprite *CreateColorSprite( int iElemID ) = 0;

		/** 
		 * @brief eNX`XvCg̍쐬vꂽɌĂяo܂B
		 * @param iElemID 쐬ꂽeNX`vCggpGg̎ID
		 * @param pTextrue gpeNX`
		 * @param pSize XvCg̃TCY
		 * @param pUV UVʒu
		 * @return eNX`XvCg
		 */
		virtual siObjectTextureSprite *CreateTextureSprite( int iElemID ) = 0;

		/** 
		 * @brief TEh̍쐬vꂽɌĂяo܂B
		 * @param iElemID 쐬ꂽIuWFNggpGg̎ID
		 * @param pSound gpTEh\[X
		 * @return TEhIuWFNg
		 */
		virtual siObjectSound *CreateSound(int iElemID, siResourceSound *pSound ) = 0;

		/** 
		 * @brief `Ǘ쐬
		 * @param iElemIDiElemID 쐬ꂽIuWFNggpGg̎ID
		 * @return IuWFNg
		 */
		virtual siObjectFont *CreateObjectFont( int iElemID ) = 0;

		/** bV`Ǘ쐬
		 * @param iVertexCount	: _
		 * @param iIndexCount	: Index
		 */
		virtual siObjectMesh *CreateMesh( int iElemID, MeshIndex::Type indexType, int iVertexCount, int iIndexCount ) = 0;


		// \[X쐬֌W
		//

		/** 
		 * @brief eNX`\[X쐬ɌĂяo܂B
		 * @param pstrPath ̓t@CpX
		 * @return null:s  !null:
		 */
		virtual siResourceTexture *CraeteTextureResource(
							seSceneManager *pSceneManager, 
							const glb::glbString *pstrPath,
							const glbVector2I *pTextureSize ) = 0;

		/** 
		 * @brief TEh̃\[X쐬ɌĂяo܂B
		 * @param pstrPath ̓t@CpX
		 * @return null:s  !null:
		 */
		virtual siResourceSound *CraeteSoundResource(
							seSceneManager *pSceneManager,
							const glb::glbString *pstrPath ) = 0;

		// }XN֌W
		//

		/** V}XNo^
		 * @brief }XN`悪Ă΂钼OɐV}XN̑S̗̈\}gNXƂ
		 * ̃\bhĂ΂܂B
		 * RegisterMask͐V}XNݒ肷xɌĂ΂܂B
		 * }XN̑傫͈̃TCYƃ}gNX|ʂZoł܂B
		 * @param pm }XN̕ό`}gNX
		 * @param pSize }XÑTCY
		 */
		virtual void RegisterMask( const IGLMatrix *pm, const glbVector2 *pSize ) = 0;

		/** }XN̏Iʒm
		 * @brief [U}XNIݒvf`悵ɌĂ΂܂B
		 */
		virtual void ClearMask() = 0;

		/** fobOpo
		 * @brief CxgAJp̏񂪔Mꂽɂ̃\bhĂ΂܂B
		 * @param pstrMsg bZ[We
		 */
		virtual void DebugString(const glb::glbString *pstrMsg ) = 0;

		/** 
		 * @brief fXgN^
		 */
		virtual ~siIOManager(){}
	};
}
#endif // INCLUDE_SIIOMANAGER_H
