#include "glbPch.h"
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "evc/file/IseStateIO.h"
#include "seStringPair.h"

using namespace glb;
namespace evc
{
	// fXgN^
	seStringPair::~seStringPair()
	{
		this->Clear();
	}

	const glbString * seStringPair::GetString( const glbString * pKey )
	{
		est::map<glbString *,glbString *>::iterator It = this->dicStringPair.begin();
		while( It != this->dicStringPair.end() )
		{
			if ( *(It->first) == *pKey )
				return It->second;
			It ++;
		}
		// L[݂Ȃ
		return null;
	}

	void seStringPair::Clear()
	{
		est::map<glbString *,glbString *>::iterator It = this->dicStringPair.begin();
		while( It != this->dicStringPair.end() )
		{
			delete It->first;
			delete It->second;
			It ++;
		}

		this->dicStringPair.clear();
	}

	void seStringPair::Add(const glbString * pKey, const glbString * pData)
	{
		glbString *pNewKey = pKey->Clone();
		glbString *pNewData = pData->Clone();
		this->dicStringPair[ pNewKey ] = pNewData;
	}

	void seStringPair::Load(IseStateInput *pInput)
	{
		int iCount = static_cast<int>(pInput->ReadShort());
		for (int i = 0; i < iCount; i++)
		{
			const glbString sKey = pInput->ReadString();
			const glbString sValue = pInput->ReadString();
			this->Add( &sKey, &sValue );
		}
	}
}
