/**
 * @file evInputControl.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVINPUTCONTROL_H
#define EVINPUTCONTROL_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "glb/SingletonCtrl.h"
#include "evc/IO/siEventIO.h"
#include "evVariableSp.h"

using namespace glb;
namespace evc
{
	class seElem;

	// Cxg̓Rg[
	class evInputControl : public seSingleton
	{
	public:
		// VOg
		GLB_SINGLETON( evInputControl )

	private : 
		seElem			 *pMostTopHit;			// ŏɃqbgGg
		glbVector2		 sBfoPointer;			// Õ}EXʒu
		glbVector2		 sPointer;			// ݂̃}EXʒu
		ButtonType::Type eFirstPushButton;	// O܂ŉĂȂA̍XVŉꂽ{^
		ButtonType::Type ePushButton;			// ݂̉Ă{^
		ButtonType::Type eBfoPushButton;		// ỎĂ{^
		bool bMovePointer;

	public:
		evInputControl()
			: pMostTopHit( null )			// ŏɃqbgGg
			, sBfoPointer( glbVector2::Zero )			// Õ}EXʒu
			, sPointer( glbVector2::Zero )			// ݂̃}EXʒu
			, eFirstPushButton( ButtonType::Non )	// O܂ŉĂȂA̍XVŉꂽ{^
			, ePushButton( ButtonType::Non )			// ݂̉Ă{^
			, eBfoPushButton( ButtonType::Non )		// ỎĂ{^
			, bMovePointer( false )
		{}

		seElem *MostTopHit() const { return this->pMostTopHit; }


		// O܂ŉĂȂA̍XVŉꂽ{^ۂ
		// w̏ꍇ́AꂩꂽȂtrueB
		bool IsFirstPush( ButtonType::Type eBtnType ) const;
		// {^Ă
		// w̏ꍇ́AꂩꂽȂtrueB
		bool IsPush(ButtonType::Type eBtnType) const;

		// |C^ʒu擾
		const glbVector2 *Pointer() const { return &this->sPointer; }

		// |C^ۂ
		bool IsMovePointer() const { return this->bMovePointer; }

		// O񂩂̈ړʂ擾
		glbVector2 GetMouseMoveOffset() const;


		// ̓CxgXV
		void Update();
	};
}
#endif //EVINPUTCONTROL_H

