/**
 * @file evVariableManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVVARIABLEMANAGER_H
#define EVVARIABLEMANAGER_H
#pragma once
#include "evc/common/seIDManager.h"
#include "evVariable.h"


namespace evc
{
	class IseStateInput;

	// ϐO[v
	class evVariableGroup : public seIDManager<evVariable*>
	{
	private:
		static const int LocalBaseID = 1000;
	public:
		// RXgN^
		evVariableGroup(int iBaseID);
		evVariableGroup();
		virtual ~evVariableGroup();

		// ĐɕҏŴ݂̂𕡐AȊO͎QƃRs[܂B
		// SȃRs[KvȏꍇDeepClonegpĉB
		evVariableGroup *Clone();

		// [h
		void Load(IseStateInput *pReader);
	};

	// ϐ̃O[v^Cv
	struct VariableGroup
	{
		enum Type
		{
			Global, // S
			Local, // Gg
			Sp, // 
		};
	};


	// ϐǗ(1V[ɂP)
	class evVariableManager
	{
	private:
		static const int GlobalBaseID = 5000; // S̕ϐID

		// S̕ϐǗ
		evVariableGroup *pGlobalGroup;
		bool bClone;
	public:
		evVariableGroup *GlobalGroup() { return this->pGlobalGroup; }

		// ϐǗ
		evVariableGroup *SpGroup();


		// RXgN^
		evVariableManager();
		// RXgN^(N[p)
		evVariableManager(evVariableGroup *pGlobal);
		// fXgN^
		virtual ~evVariableManager();


		// ϐO[v擾
		VariableGroup::Type GetGroupType(evVariable *pVariable);

		void Clear();


		// N[
		// ĐɕҏŴ݂̂𕡐AȊO͎QƃRs[܂B
		// SȃRs[KvȏꍇDeepClonegpĉB
		evVariableManager *Clone();

		// t@C̃[h
		void Load(IseStateInput *pReader);

	};
}
#endif //EVVARIABLEMANAGER_H

