#include "glbPch.h"
#include "glb/glbString.h"
#include "evc/common/seDefine.h"
#include "evc/file/IseStateIO.h"
#include "evVariableSp.h"
#include "evInputControl.h"
using namespace glb;
namespace evc
{
	evVariable *evVariableSp::Find(VariableSp::Type eSpType)
	{
		return this->evVariableGroup::Find(static_cast<int>(eSpType));
	}

	evVariableSp::evVariableSp() : evVariableGroup(evVariableSp::SpBaseID)
	{
		// lϐ쐬
		this->Add(static_cast<int>(VariableSp::MouseAddX), evc_new evVariableNum());
		this->Add(static_cast<int>(VariableSp::MouseAddY), evc_new evVariableNum());
		this->Add(static_cast<int>(VariableSp::MouseX), evc_new evVariableNum());
		this->Add(static_cast<int>(VariableSp::MouseY), evc_new evVariableNum());
		this->Add(static_cast<int>(VariableSp::Random), evc_new evVariableRandomNum());
	}

	/** 
	 * fXgN^
	 */
	evVariableSp::~evVariableSp()
	{
		this->DeleteAllInstance();
	}

	// ϐ̐lϐɒlݒ
	#define SetNumValue( _Type, _Value )		\
	{							\
		evVariableNum *pNum = static_cast<evVariableNum*>(this->Find(_Type));	\
		pNum->Value( _Value );	\
	}

	void evVariableSp::Update(evInputControl *pEventInput)
	{
	
		// }EXړȂ
		if (pEventInput->IsMovePointer())
		{
			const glbVector2 *sMousePos = pEventInput->Pointer();
			SetNumValue(VariableSp::MouseX, static_cast<int>(sMousePos->X));
			SetNumValue(VariableSp::MouseY, static_cast<int>(sMousePos->Y));
	
			glbVector2 sMoveOffset = pEventInput->GetMouseMoveOffset();
			SetNumValue(VariableSp::MouseAddX, static_cast<int>(sMoveOffset.X));
			SetNumValue(VariableSp::MouseAddY, static_cast<int>(sMoveOffset.Y));
		}
		// ړĂȂȂ
		else
		{
			SetNumValue(VariableSp::MouseAddX, 0);
			SetNumValue(VariableSp::MouseAddY, 0);
		}
	}
}
