/**
 * @file bnInput.h
 * @brief 
 *
 * @author seri
 */
#ifndef BNINPUT_H
#define BNINPUT_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "IseStateIO.h"

namespace evc
{
	// [_[NX
	class bnInput : public IseStateInput
	{
	private:
		int iIndex;
		const est::vector<glb::Byte> *pbBuffer;

	public:
		// RXgN^
		bnInput() : iIndex( 0 ), pbBuffer( null ) {}

		// I[v
		void Open(const est::vector<glb::Byte> *buffer);


		// N[Y
		void Close();

		bool ReadBool();
		unsigned char ReadByte();
		short ReadShort();
		int ReadInt();
		float ReadFloat();
		glbString ReadString();

	};
}
#endif //BNINPUT_H

