#include "glbPch.h"
#include "seElemAnimManager.h"
#include "seElemAnim.h"
#include "evc/scene/seSceneManager.h"
#include "evc/file/IseStateIO.h"

using namespace glb;
namespace evc
{
	// fXgN^
	seElemAnimManager::~seElemAnimManager()
	{
		this->DeleteAllInstance();
	}


	void seElemAnimManager::Load(IseStateInput *pInput, seSceneManager *pManager)
	{
		this->Clear();

		int iCount = static_cast<int>(pInput->ReadShort());
		seDefine::DebugTrace( "AnimCount", iCount);
		for (int i = 0; i < iCount; i++)
		{
			int iAnimID = static_cast<int>(pInput->ReadShort());
			seDefine::DebugTrace( "AnimID", iAnimID);
			seElemAnim *pElemAnim = evc_new seElemAnim();
			pElemAnim->Load(pInput, pManager);
			this->Add(iAnimID, pElemAnim);
		}
	}
}
