/**
 * @file seFontLine.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEFONTLINE_H
#define SEFONTLINE_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbVector.h"

using namespace glb;
namespace glb
{
	class IGLMatrix;
	struct glbColor;
}
namespace evc
{
	class seFontChar;

	// PsǗ
	class seFontLine
	{
	private:
		glbVector2 sSize;
		est::vector<seFontChar*> lisFontChar;

	public:
		// RXgN^
		seFontLine(float fHeight);
		virtual ~seFontLine();

		const est::vector<seFontChar*> *Char() const { return &this->lisFontChar; }

		// Ō̃L擾
		seFontChar *GetLastChar();

		// s̃TCY擾
		const glbVector2 *Size() const { return &this->sSize; }

		// f[^̔f
		void Apply();

		void Add(seFontChar *pChar);

		// `
		bool Draw( int iElemID, 
					float fHeight,
					const IGLMatrix *mParent, 
					const glbColor *sColor, 
					int iDrawNum, 
					int &iNowCount );
	};
}
#endif //SEFONTLINE_H

