/**
 * @file IGLMatrix.h
 * @brief }gNXǗ
 *
 * @author seri
 */
#ifndef INCLUDE_IGLMATRIX_H
#define INCLUDE_IGLMATRIX_H
#include "glb/glbDefine.h"
#include "glb/glbVector.h"



namespace glb
{
	/** }gNXǗ
	 */
	class IGLMatrix
	{
	public:

		/** 
		 * @brief fXgN^
		 */
		virtual ~IGLMatrix(){}

		/** XP[}gNX쐬
		 * @brief 
		 * @param x
		 * @param y
		 * @param z
		 */
		virtual void SetScale(float x, float y) = 0;
		virtual void SetScale( const glbVector2 *pScale ) = 0;
		/** ړ}gNX쐬
		 * @brief
		 * @param x
		 * @param y
		 * @param z
		 */
		virtual void SetPos(float x, float y) = 0;
		virtual void SetPos( const glbVector2 *pPos ) = 0;

		/** Z]}gNX쐬
		 * @brief 
		 * @param z
		 */
		virtual void SetRotZ(float z) = 0;

		/** eNX`pUV}gNX쐬
		 * @brief 
		 * @param u
		 * @param v
		 */
		virtual void SetUV(float u, float v) = 0;
		virtual void SetUV( const glbVector2 *pUV ) = 0;

		/** |Z
		 * @brief
		 * @param pm Ώۃ}gNX
		 */
		virtual void Mul( const IGLMatrix *pm) = 0;
		/** |Z
		 * @brief MulƂ͋t炩܂
		 * @param pm Ώۃ}gNX
		 */
		virtual void MulR( const IGLMatrix *pm ) = 0;


		/** 2DxNgƊ|Z
		 * @brief 
		 * @param pv Ώ2DxNg
		 * @return Z
		 */
		virtual glbVector2 TransformCoordinate( const glbVector2 *pv ) const = 0;

		/** lRs[ (O̕ύX)
		 * @brief 
		 * @param pm
		 */
		virtual void Copy( const IGLMatrix *pm ) = 0;

		/** 
		 * @brief t}gNXɕϊ
		 */
		virtual void Invert() = 0;

		/** 
		 * @brief Pʃ}gNXɂ
		 */
		virtual void Identity() = 0;
	};
}
#endif // INCLUDE_IGLMATRIX_H
