#include "glbPch.h"
#ifdef PR_MEM_DEBUG

#include "op_mem.h"

#ifdef WIN32
#include <windows.h>
#include <tchar.h>
#include <stdarg.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "glbDebug.h"

#define PUT_UNKNOWN_ADDR		// unknown̎AhXo


#ifndef NULL
#define NULL 0
#endif

// ZeroMemorypӂĂȂꍇmemsetgp
#ifndef ZeroMemory
#define ZeroMemory(Destination,Length) memset((Destination),0,(Length))
#endif

// ԃpXTCY
#define MEM_INFO_PATH	256

// fobOǗ\
struct MEMDB_INFO
{
	char		name[ MEM_INFO_PATH ];
	MEMDB_INFO	*pBfoMem;
	MEMDB_INFO	*pNextMem;
	int			iWork;

};

static int s_iNewCount = 0;

// ŌɊmۂꂽ̈
static MEMDB_INFO *s_pLastMemInfo = NULL;


// fobOpm
static void * evc_new_sub(size_t size, const char *pcFunc, int iLine)
{
	// unknowñ[NTɎgp܂B
#if 0
	// ̃TCỸ
	if ( (::strcmp( "unknown", pcFunc )== 0) && (iLine == 24) )
	{
		int i = 0;
	}
#endif

	MEMDB_INFO *pMemInfo = (MEMDB_INFO *)malloc( sizeof(MEMDB_INFO) + size );
	ZeroMemory(pMemInfo, sizeof(MEMDB_INFO));

#ifdef WIN32
	sprintf_s( pMemInfo->name, MEM_INFO_PATH, "%s(%d)\0", pcFunc, iLine );
#else
	sprintf( pMemInfo->name, "%s(%d)", pcFunc, iLine );
#endif

	// ŏ̗̈mۂȂ
	if ( s_pLastMemInfo == NULL )
	{
		pMemInfo->pBfoMem = NULL;
	}
	// `F[ɒǉ
	else
	{
		s_pLastMemInfo->pNextMem = pMemInfo;
		pMemInfo->pBfoMem = s_pLastMemInfo;
	}

	// ŌɊmۂ̈XV
	s_pLastMemInfo = pMemInfo;
	pMemInfo->pNextMem = NULL;

	s_iNewCount++;
#if 0
	// ̃AhX̃
	if ( (int)(pMemInfo + 1) == 0x3fd8f4 )
	{
		int stop = 0;
	}
#endif

	MEMDB_INFO *pRet = pMemInfo + 1;
	return pRet;
}

void * operator new(size_t size ) throw() { return evc_new_sub( size, "unknown", size ); }
void * operator new(size_t size, const char *pcFunc, int iLine) throw() { return evc_new_sub( size, pcFunc, iLine ); }
void * operator new[](size_t size, const char *pcFunc, int iLine) throw() { return evc_new_sub( size, pcFunc, iLine ); }



// fobOp
static void delete_sub( void *p )
{
	MEMDB_INFO *pMemInfo = (MEMDB_INFO *)((char *)p - sizeof(MEMDB_INFO));


	// `F[̐擪폜ꂽȂ
	if ( pMemInfo->pBfoMem == NULL )
	{
		if ( pMemInfo->pNextMem != NULL )
		{
			pMemInfo->pNextMem->pBfoMem = NULL;
		}

		// 擪ƍŌオȂ
		if ( pMemInfo == s_pLastMemInfo )
		{
			// S폜
			s_pLastMemInfo = NULL;
		}
	}
	// `F[̓r܂͍Ōオ폜ꂽȂ
	else
	{
		MEMDB_INFO *pBfo = pMemInfo->pBfoMem;
		MEMDB_INFO *pNext = pMemInfo->pNextMem;

		pBfo->pNextMem = pNext;
		// Ō̏ꍇNext݂Ȃ
		if ( pNext == NULL )
		{
			// ŏImۈʒuXV
			s_pLastMemInfo = pBfo;
		}
		else
		{
			pNext->pBfoMem = pBfo;
		}
	}

	s_iNewCount --;
	free( pMemInfo );
}

void operator delete(void * p, const char *pcFunc, int iLine ) throw() { delete_sub( p ); }
void operator delete[](void * p, const char *pcFunc, int iLine ) throw() { delete_sub( p ); }
void operator delete(void * p ) { delete_sub( p ); }
void operator delete[](void * p ) { delete_sub( p ); }


// ݂̊mے̃WvđSĕ\
void OutputDbMemInfo()
{
	// [NNA
	MEMDB_INFO *pMemInfo = s_pLastMemInfo;
	for(; pMemInfo != NULL; pMemInfo = pMemInfo->pBfoMem )
	{
		pMemInfo->iWork = 0;
	}

	GLB_DB_STRING( "========= evc_new Count[ %d ] =========\n", s_iNewCount );
	

	// Wvĕ\
	pMemInfo = s_pLastMemInfo;
	for(; pMemInfo != NULL; pMemInfo = pMemInfo->pBfoMem )
	{
		// ɏWvς
		if ( pMemInfo->iWork != 0 ) continue;

#ifdef PUT_UNKNOWN_ADDR
		bool bUnknown = false;
		// mȂAhXo
		if ( strncmp( "unknown", pMemInfo->name, strlen("unknown") ) == 0 )
		{
			bUnknown = true;
			GLB_DB_STRING( "unknown addr : [%x]\n", pMemInfo + 1 );
		}
#endif // PUT_UNKNOWN_ADDR

		int iCount = 1;
		MEMDB_INFO *pWork = pMemInfo->pBfoMem;
		for(; pWork != NULL; pWork = pWork->pBfoMem )
		{
			if ( strcmp( pWork->name, pMemInfo->name ) == 0 )
			{
#ifdef PUT_UNKNOWN_ADDR
				// unknownȂAhXo
				if ( bUnknown )
				{
					GLB_DB_STRING( "unknown addr : [%x]\n", pWork + 1 );
				}
#endif // PUT_UNKNOWN_ADDR

				pWork->iWork = 1;
				iCount++;
			}
		}
	
		GLB_DB_STRING( "%s : [%d]\n", pMemInfo->name, iCount );
	}
}

#endif // PR_MEM_DEBUG
