#include "stdafx.h"
#include "glb/glbDefine.h"
#include "glb/glbString.h"
#include "EventListener.h"

using namespace glb;
namespace evc
{
	// {ACxg̓̕f[^œꂷ
	// ΉKv͂ȂA܂ׂłB
	// {\[X͂f[^ɑΉł悤
	// ȉ̂悤ȏɂȂĂ܂B

	// ̕tH[}bgCxg^Cv
	class EventKeys
	{
	private:
		UserEventType Type;		// Cxg^Cv
		glbString Jis;
		glbString Utf16;

	public:
		// Cxg^Cv擾
		UserEventType EventType() const { return this->Type; }

		// RXgN^
		EventKeys( UserEventType eType, char *pText1, GLB_UNICODE *pText2 )
			: Type(eType), Jis( pText1 ), Utf16( pText2 ){}

		// 񂩔
		bool IsSame( const glbString *pText ) const
		{
			if ( pText == null ) return false;

			bool bSame = false;
			switch( pText->Format() )
			{
				case seTextFormat::Shift_Jis:
					bSame = ((*pText) == this->Jis);
					break;
				case seTextFormat::Utf16:
					bSame = ((*pText) == this->Utf16);
					break;
				default:
					break;
			}
			return bSame;
		}


	};

	// 񂩂Cxgm
	UserEventType EventListener::GetEventType( const glbString *pText )
	{
		if ( pText == null) return Non;

		est::vector<EventKeys*>::iterator it = this->lisKeys.begin();

		for(;it != this->lisKeys.end(); it++ )
		{
			if ( (*it)->IsSame( pText ) )
			{
				return (*it)->EventType();
			}
		}
		return Non;
	}


	EventListener::EventListener()
	{
		this->lisKeys.push_back( new EventKeys( Hour,   "Hour",   (GLB_UNICODE *)L"Hour"   ));
		this->lisKeys.push_back( new EventKeys( Minute, "Minute", (GLB_UNICODE *)L"Minute" ));
		this->lisKeys.push_back( new EventKeys( Second, "Second", (GLB_UNICODE *)L"Second" ));
	}

	EventListener::~EventListener()
	{
		glb::DeleteVector( this->lisKeys );
	}


	// l̎擾
	int EventListener::GetValue( const glbString *pCallName, int iElemID )
	{
		SYSTEMTIME stTime;

		switch( this->GetEventType( pCallName ) )
		{
			case Hour:
				{
					GetLocalTime(&stTime);
					return (int)stTime.wHour;
				}
			case Minute:
				{
					GetLocalTime(&stTime);
					return (int)stTime.wMinute;
				}
			case Second:
				{
					GetLocalTime(&stTime);
					return (int)stTime.wSecond;
				}
			default:
				break;
		}
		return 0;
	}

	// ߌĂяo
	void EventListener::CallCommand( const glbString *pCallName, int iElemID, int iValue )
	{


	}
}

