#include "stdafx.h"
#include <windows.h>
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "evc/scene/seRootScene.h"
#include "io/dxIOManager.h"
#include "io/dxEventIO.h"
#include "io/dxMaterial.h"
#include "EventListener.h"

using namespace dx;
using namespace glb;
using namespace evc;

static seRootScene	*s_pRootScene   = NULL; //!< V[Ǘ
static dxIOManager	*s_pDxIOManager = NULL; //!< o̓}l[W
static dxEventIO	*s_pDxEventIO   = NULL; //!< Cxg͊Ǘ
static dxMaterial	*s_pDxMaterial  = NULL; //!< }eAo͊Ǘ
static EventListener *s_pEventListener = NULL; //!< CxgXi[

/** 
 * AvP[VNɂPxĂ΂܂B
 */
dxEventIO *teInit()
{
	//! o̓NX쐬
	s_pDxIOManager = evc_new dxIOManager();
	s_pDxEventIO   = evc_new dxEventIO();
	s_pDxMaterial  = evc_new dxMaterial();


	//! V[NX쐬
	s_pRootScene = evc_new seRootScene( s_pDxIOManager,
	                                    s_pDxEventIO, 
	                                    s_pDxMaterial );

	//! CxgXi[쐬
	s_pEventListener = evc_new EventListener();
	s_pRootScene->EventListener( s_pEventListener );

	//! prat@C̈ʒuJgɂ
	::SetCurrentDirectory( L"../../data/" );
//	glb::glbString strPraName( (GLB_UNICODE *)L"tes_move.pra" );
//	glb::glbString strPraName( (GLB_UNICODE *)L"default.pra" );
//	glb::glbString strPraName( (GLB_UNICODE *)L"mesh.pra" );
//	glb::glbString strPraName( (GLB_UNICODE *)L"mesh_girl.pra" );
//	glb::glbString strPraName( (GLB_UNICODE *)L"path_anim.pra" );
//	glb::glbString strPraName( (GLB_UNICODE *)L"particle.pra" );
//	glb::glbString strPraName( (GLB_UNICODE *)L"grid_tes.pra" );
	glb::glbString strPraName( (GLB_UNICODE *)L"mask_tes.pra" );

	glb::glbString strAnimName( "default" );
//	glb::glbString strAnimName( (GLB_UNICODE *)L"default" );
	s_pRootScene->Load( &strPraName, &strAnimName );
	return s_pDxEventIO;
}


/** t[
 * teIniťAɌĂ΂ꑱ܂B
 */
void teProc()
{
	//! ͏XV
	s_pRootScene->UpdateInput();

	//! Aj[V̎s
	s_pRootScene->DoAnim( 16 );

	//! vf̕`
	s_pRootScene->Draw();
}


/** I
 * AvP[VIɂPxĂ΂܂B
 */
void teTerm()
{
	delete s_pRootScene;
	delete s_pDxIOManager;
	delete s_pDxEventIO;
	delete s_pDxMaterial;
	delete s_pEventListener;
}
