#ifndef INCLUDE_DX_CONTROL_H
#define INCLUDE_DX_CONTROL_H
#include <cassert>
#include <windows.h>
#include <d3d9.h>

//Direct3D9t[[NNX
class dx_control
{
private:
	LPDIRECT3D9				pD3D;
	LPDIRECT3DDEVICE9		pDevice;
	D3DPRESENT_PARAMETERS	param;
	BOOL					bDeviceLost;
	D3DCOLOR				sBgColor;		// wiF
	SIZE					sScreen;		// XN[TCY
	bool					bUpdateSize;	// obt@TCYύXꂽ
	int						iMaxLightCount;	// Cg̍ő吔

	// RXgN^
	dx_control();

public:
	// VOg
	static dx_control &Instance()
	{
		static dx_control instance;
		return instance;
	}

	// foCX擾
	LPDIRECT3DDEVICE9 Device() const
	{
		assert( this->pDevice != NULL );
		return this->pDevice; 
	}


	// fXgN^
	~dx_control();


	// wiF̎擾Eݒ
	void BgColor( D3DCOLOR sNewColor ) { this->sBgColor = sNewColor; }
	D3DCOLOR BgColor() const		   { return this->sBgColor; }

	// XN[TCY̎擾Eݒ
	void Screen( const SIZE &sSize ) 
	{
		this->sScreen = sSize;
		this->bUpdateSize = true;
	}
	const SIZE *Screen() const		 { return &this->sScreen; }

	// 
	HRESULT Init(HWND hWnd, BOOL bWin);

	// `
	HRESULT Render( void (*pFunc)( IDirect3DDevice9 *pDevice, void *pvData ), void *pvUserData );

	


	// 
	HRESULT Dispose();
};

#endif // INCLUDE_DX_CONTROL_H