#include "stdafx.h"
#include <windows.h>
#include "font_control.h"




// RXgN^
font_control::font_control( LPCWSTR pFace, int iHeight, BOOL bBold )
	: hOldFont( 0 )
	, hWorkDC( 0 )
{
	this->hFont = ::CreateFontW(
					// C`PʂemTCYw
					-MulDiv (iHeight, GetDeviceCaps (GetDC(NULL), LOGPIXELSY), 72),
					0,			// 
					0,		//eLXg̊px 
					0,			//x[XCƂƂ̊px 
					(bBold == TRUE) ? FW_DEMIBOLD : FW_NORMAL, //tHg̏dij 
					FALSE,		//C^bN 
					FALSE,		//A_[C 
					FALSE,		//ł 
					DEFAULT_CHARSET,
					OUT_DEFAULT_PRECIS,			//o͐x 
					CLIP_DEFAULT_PRECIS,		//NbsOx 
//					PROOF_QUALITY,				//o͕i 
					ANTIALIASED_QUALITY,		// o͕i 
					DEFAULT_PITCH|FF_DONTCARE,	//sb`ƃt@~[ 
					pFace );						//̖ 
}

// RXgN^
font_control::font_control( LPCSTR pFace, int iHeight, BOOL bBold )
	: hOldFont( 0 )
	, hWorkDC( 0 )
{
	this->hFont = ::CreateFontA(
					// C`PʂemTCYw
					-MulDiv (iHeight, GetDeviceCaps (GetDC(NULL), LOGPIXELSY), 72),
					0,			// 
					0,		//eLXg̊px 
					0,			//x[XCƂƂ̊px 
					(bBold == TRUE) ? FW_DEMIBOLD : FW_NORMAL, //tHg̏dij 
					FALSE,		//C^bN 
					FALSE,		//A_[C 
					FALSE,		//ł 
					DEFAULT_CHARSET,
					OUT_DEFAULT_PRECIS,			//o͐x 
					CLIP_DEFAULT_PRECIS,		//NbsOx 
//					PROOF_QUALITY,				//o͕i 
					ANTIALIASED_QUALITY,		// o͕i 
					DEFAULT_PITCH|FF_DONTCARE,	//sb`ƃt@~[ 
					pFace );						//̖ 
}


// fXgN^
font_control::~font_control()
{
	if ( this->hFont != NULL )
	{
		::DeleteObject( this->hFont );
		this->hFont = NULL;
	}

}

// TCY擾
glbVector2 font_control::GetCharSize( short sChar )
{
	HDC hdc = ::GetDC( NULL );
	HFONT hOldFont = (HFONT)::SelectObject( hdc, this->hFont );

	SIZE sRetSize;
	WCHAR s[] = { sChar };
	::GetTextExtentPoint32W( hdc, s, 1, &sRetSize );

	// IuWFNgɖ߂
	::SelectObject( hdc, hOldFont );
	::ReleaseDC( NULL, hdc );

	return glbVector2( (float)sRetSize.cx, (float)sRetSize.cy );
}

// TCY擾
glbVector2 font_control::GetCharSize( char cChar )
{
	HDC hdc = ::GetDC( NULL );
	HFONT hOldFont = (HFONT)::SelectObject( hdc, this->hFont );

	SIZE sRetSize;
	CHAR s[] = { cChar };
	::GetTextExtentPoint32A( hdc, s, 1, &sRetSize );

	// IuWFNgɖ߂
	::SelectObject( hdc, hOldFont );
	::ReleaseDC( NULL, hdc );

	return glbVector2( (float)sRetSize.cx, (float)sRetSize.cy );
}



// 擾
void font_control::GetInfo( LOGFONT *pLogFont )
{
	::GetObject((HGDIOBJ)this->hFont, sizeof(LOGFONT), (LPVOID)pLogFont);
}

// tHgI
void font_control::Begin( HDC hdc )
{
	this->hOldFont = (HFONT)::SelectObject( hdc, this->hFont );
	this->hWorkDC = hdc;
}

// tHggpI錾
void font_control::End()
{
	::SelectObject( this->hWorkDC, this->hOldFont );
	this->hOldFont = 0;
	this->hWorkDC = 0;
}



