#ifndef INCLUDE_DXRESOURCE_H
#define INCLUDE_DXRESOURCE_H

#include "glb/glbDefine.h"
#include "evc/IO/siResource.h"

struct IDirect3DTexture9;

using namespace glb;
using namespace evc;
namespace dx
{
	class WavFormatCtrl;


	// TEh\[X
	class dxResourceSound : public siResourceSound
	{
	private:
		static const int MIN_STREAM_SIZE = 	1024 * 200;		// ŒXg[TCY:Ƃ肠200K

		// WavtH[}bg擾
		WavFormatCtrl		*pWavFormat;
		est::istream		*pStream;
		bool				bFileStream;
		est::vector<char>	stvMemBuffer;
	public:

		// WavFormat̎擾
		WavFormatCtrl *WavFormat()	{ return this->pWavFormat; }

		// t@CXg[̎擾
		est::istream *Stream()		{ return this->pStream; }


		// RXgN^
		dxResourceSound( const glb::glbString *pcName );


		// \[X̏
		virtual siResourceInit::Type Init( const est::vector<glb::Byte> *buffer );

		virtual ~dxResourceSound();
	};


	// eNX`\[X
	class dxResourceTexture : public siResourceTexture
	{
	private:
		IDirect3DTexture9			*pTexture;
		glbVector2I					sImageSize;
		est::vector<unsigned char>	stvHit;
	public:
		// RXgN^
		dxResourceTexture( const glb::glbString *pcName );
		virtual ~dxResourceTexture();

		// eNX`擾
		IDirect3DTexture9 *Texture() const { return this->pTexture; }

		// \[X̏
		virtual siResourceInit::Type Init( const est::vector<glb::Byte> *buffer );

		// eNX`TCY:
		// eNX`̕AԂĉB
		virtual const glbVector2I *TextureSize() { return &this->sImageSize; }

		/** 蔻
		 * @brief w̍W̃C[WȂtrueA
		 * łȂȂfalseԂĉB
		 * @return C[WƂ̃qbg
		 */
		virtual bool IsHit( const glbVector2I *pHitPos );


		// eNX`̃NA
		static void Clear();
	};


}
#endif // INCLUDE_SIRESOURCE_H