#ifndef INCLUDE_DXOBJECTFONTMANAGER_H
#define INCLUDE_DXOBJECTFONTMANAGER_H
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
//#include "dxObjectFont.h"


struct IDirect3DTexture9;
class bmp_control;


namespace evc
{
	class siObjectFontChar;
}

using namespace glb;
using namespace evc;
namespace dx
{
	class dxObjectFont;
	class dxObjectFontChar;
	class dxObjectFontStyleManager;

	typedef est::map<int,dxObjectFontChar*> char_map;


	// LXgǗ
	class dxCharList
	{
	private:
		est::map<int,dxObjectFontChar *> dicChar;

	public:
		dxCharList(){}
		virtual ~dxCharList();

		// Cӂ̃tH[}bgƕR[h
		dxObjectFontChar *Find( seTextFormat::Type eFormat, short sChar ); 

		// Po^
		void Add( dxObjectFontChar *pFont, seTextFormat::Type eFormat, short sChar );

		// eNX`ǉ
		void RegisterTextureInfo( IDirect3DTexture9 *pTexture, const glbVector2I *pTexSize );


		void Clear();
	};


	// pC[WǗ
	class dxObjectFontImageManager 
	{
	private:
		static const int	ImageSize = 256;	// C[W̃TCY(`)

		dxObjectFont		*pParent;
		glbVector2			sImagePutWorkPos;	// Ōɕ\ʒu()
		float				fLineY;				// ő僉C(ԉ܂łĂf[^)
		bmp_control			*pNowBmp;
		// gpeNX`Xg
		est::vector<IDirect3DTexture9*>		lisTexture;
		// f[^Xg
		est::map<int,dxCharList *>		dicFontStyle;
		// X^CǗNX
		dxObjectFontStyleManager	*pStyleManager;

		// vZp
		int iPixCount;

	public:
		// RXgN^
		dxObjectFontImageManager( dxObjectFont *pParent );
		virtual ~dxObjectFontImageManager();

		// eNX`Xg
		const est::vector<IDirect3DTexture9*> *TextureList() const { return &this->lisTexture; }

		// bmp擾
		bmp_control *Bmp() const { return this->pNowBmp; }

		// JE^擾
		int PixCount() const { return this->iPixCount; }
		// JE^Z
		void IncPixCount() { this->iPixCount++; }


		// ǗNX쐬
		dxObjectFontChar *CreateChar( int iFontStyle, seTextFormat::Type eFormat, short sChar );

		// tHgX^C쐬
		int CreateFontStyle( const glb::glbString *strFontName, float fHeight, seFontStyle::Type Style );


		// ̈̉
		void Dispose();

		// f[^SăNA
		void Clear();


		// o^̎c̃f[^o
		void Flush();

		// bitmapɃLC[Wl߂
		dxObjectFontChar *CreateCharImage( int iFontStyle, int cChar );


		// tH[}bgƃLR[hLʃR[h𐶐
		static int CreateCharCode( seTextFormat::Type eFormat, short sChar );

	private:
		// bmpeNX`ɂnullo^ĂLɐݒ
		void CnvTexture();

		// bmpC[WNA
		void ClearImage();
	};

}



#endif // INCLUDE_DXOBJECTFONTMANAGER_H