﻿#include "stdafx.h"
#include "glb/glbDefine.h"
#include "ChunkInfo.h"

using namespace glb;
namespace dx
{
	// ファイルストリームからチャンク情報を登録
	// ストリームの位置はデータのところまで移動
	void ChunkInfo::Register( est::istream &inStream )
	{
		inStream >> this->iChunkID;
		inStream >> this->iChunkSize;
		this->lOffset = inStream.tellg();
	}

	// 次のチャンクへストリームを移動
	void ChunkInfo::NextChunk( est::istream &inStream )
	{
		inStream.seekg( this->lOffset + (long)this->iChunkSize, est::ios::beg );
	}
}
