﻿#ifndef INCLUDE_CHUNKINFO_H
#define INCLUDE_CHUNKINFO_H
#include "glb/glbDefine.h"

using namespace glb;
namespace dx
{
	// チャンク情報
	class ChunkInfo
	{
	public:
		static const int Fmt = 0x20746d66;	// "fmt "
		static const int Data = 0x61746164;	// "data"

		int		iChunkID;
		int		iChunkSize;					// チャンクサイズ
		long	lOffset;					// データオフセット
		
		// ファイルストリームからチャンク情報を登録
		// ストリームの位置はデータのところまで移動
		void Register( est::istream &inReader );

		// 次のチャンクへストリームを移動
		void NextChunk( est::istream &inReader );

	};
}
#endif // INCLUDE_CHUNKINFO_H