#ifndef INCLUDE_NNMATRIX_H
#define INCLUDE_NNMATRIX_H
#include "glb/IGLMatrix.h"


using namespace glb;
namespace nn
{
	class nnMatrix : public IGLMatrix
	{
	public:
		virtual void SetScale(float x, float y ){}
		virtual void SetScale( const glbVector2 *pScale ){}

		virtual void SetPos(float x, float y ){}
		virtual void SetPos( const glbVector2 *pPos ){}

		virtual void SetRotZ(float z){}

		// eNX`}gNXpUVZbg
		virtual void SetUV(float u, float v){}
		virtual void SetUV( const glbVector2 *pUV ){}

		virtual void Mul( const IGLMatrix *pm){} // *=
		virtual void MulR( const IGLMatrix *pm ){} // *= : t|

		// Q_Ɗ|Z
		virtual glbVector2 TransformCoordinate( const glbVector2 *pv ) const
		{
			return glbVector2::Zero;
		}

		// lRs[
		virtual void Copy( const IGLMatrix *pm ){}
		// t}gNXɕϊ
		virtual void Invert(){}
		// Pʃ}gNXɂ
		virtual void Identity(){}
#if 0
		// }gNXXP[vf擾
		// (0,0) (1,1) (2,2)̗vf擾
		virtual glbVector GetScale(){ return glbVector( 1.0f, 1.0f, 1.0f ); }

		// }gNXړvf擾
		// (0,3) (1,3) (2,3)̗vf擾
		virtual glbVector GetPos(){return glbVector( 0.0f, 0.0f, 0.0f );}

		// ʒuƒ_ݒ肩}gNX𐶐
		virtual void SetLookAtLH( const glbVector *pv, const glbVector *pu, const glbVector *pp ){}

		// vWFNV}gNX𐶐
		virtual void SetPerspectiveFovLH(float w, float h, float n, float f){}
#endif 
	};
}
#endif // INCLUDE_NNMATRIX_H
