
#include "targetver.h"

#define WIN32_LEAN_AND_MEAN             // Windows wb_[gpĂȂO܂B
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include "glb/glbDefine.h"	// [NfobO֐錾
#include "glb/SingletonCtrl.h"	// [NfobO֐錾
#include "TestExec.h"


#define TIMER_ID		100		// ^C}[ID
#define TIMER_INTERVAL	16		// XVԊu


static HDC s_hPaint;

// `̃foCXReLXg擾
HDC PaintDC()
{
	return s_hPaint; 
}


// WindowTCY擾
static SIZE GetWindowSize( HWND hWnd )
{
	RECT rec;
	::GetWindowRect( hWnd, &rec );
	SIZE sSize = 
	{ 
		(LONG)rec.right - rec.left,
		(LONG)rec.bottom - rec.top
	};
	return sSize;
}


// bZ[WvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HDC s_hDC;
	static HBITMAP s_hBitmap;
	static HBITMAP s_hOldBitmap;
	SIZE sSize;

	switch (message)
	{
	case WM_CREATE:
		// 
		teInit();

		s_hDC = ::GetDC( hWnd );
		s_hPaint = CreateCompatibleDC( s_hDC );
		sSize = GetWindowSize(hWnd);
		s_hBitmap = CreateCompatibleBitmap( s_hDC, sSize.cx, sSize.cy );
		s_hOldBitmap = (HBITMAP)SelectObject( s_hPaint, s_hBitmap );

		// ^C}[ݒ
		SetTimer( hWnd, TIMER_ID, TIMER_INTERVAL, NULL );
		break;
	// ^C}[
	case WM_TIMER:
		{
			// wihԂ
			HBRUSH hBackGround = CreateSolidBrush( RGB(0,0,0) );
			sSize = GetWindowSize( hWnd );
			RECT bg = { 0,0, sSize.cx, sSize.cy };
			FillRect( s_hPaint, &bg, hBackGround);
			DeleteObject( hBackGround );

			// `
			teProc();
			::InvalidateRect( hWnd, NULL, false );
		}
		break;

	// TCYύX
	case WM_SIZE:
		// ̗̈
		SelectObject( s_hPaint, s_hOldBitmap );
		DeleteObject( s_hBitmap );

		sSize = GetWindowSize( hWnd );
		s_hBitmap = CreateCompatibleBitmap( s_hDC, sSize.cx, sSize.cy );
		s_hOldBitmap = (HBITMAP)SelectObject( s_hPaint, s_hBitmap );
		break;

	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hWnd, &ps);

			sSize = GetWindowSize( hWnd );
			BitBlt( hdc, 0, 0, sSize.cx, sSize.cy, s_hPaint,0,0,SRCCOPY );

			EndPaint(hWnd, &ps);
		}
		break;
	case WM_DESTROY:
		// ^C}j
		KillTimer( hWnd, TIMER_ID );
		// ̈̉
		SelectObject( s_hPaint, s_hOldBitmap );

		DeleteObject( s_hBitmap );
		DeleteDC( s_hPaint );
		ReleaseDC( hWnd, s_hDC );

		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// C
int APIENTRY _tWinMain(HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPTSTR    lpCmdLine,
					   int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);


	WNDCLASSEX wcex = {0};
	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.hInstance		= hInstance;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.lpszClassName	= TEXT("PR_WINDOW");
	RegisterClassEx(&wcex);


	RECT rc = { 0, 0, 640, 480 } ;
	AdjustWindowRect( &rc, WS_OVERLAPPEDWINDOW, FALSE );

	// O[oϐɃCX^Xi[܂B
	HWND hWnd = CreateWindow(
						TEXT("PR_WINDOW"), 
						TEXT("PlaneRunner Test"), 
						WS_OVERLAPPEDWINDOW,
						CW_USEDEFAULT, 
						CW_USEDEFAULT,
						rc.right - rc.left,
						rc.bottom - rc.top,
						NULL, NULL, 
						hInstance, NULL );

	if ( !hWnd ) return FALSE;

	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	// C bZ[W [v:
	MSG msg;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	// I
	teTerm();

	// VOg̉s
	SlDeleteAll();

	// ݂̊mے̃WvđSĕ\
	OutputDbMemInfo();

	return (int) msg.wParam;
}


