#ifndef INCLUDE_TSIOMANAGER_H
#define INCLUDE_TSIOMANAGER_H
#include "io/nnIOManager.h"
#include "tsFile.h"
#include "tsMatrix.h"
#include "tsObjectColorSprite.h"

using namespace glb;
using namespace evc;
using namespace nn;

// o͊Ǘ
class tsIOManager : public nnIOManager
{
public:

	// Pt@C[hǗ쐬
	// @param strPath		 : [hvt@C̃pX
	// @param pSceneManager : vt@CV[(null=[gV[)
	virtual siFile *CreateLoader( seSceneManager *pinScManager, const glb::glbString *pstrPath )
	{
		return evc_new tsFile( pstrPath );
	}

	// }gNX쐬
	virtual IGLMatrix *CreateMatrix()
	{
		return evc_new tsMatrix(); 
	}

	// J[XvCg̍쐬vꂽɌĂяo܂B
	virtual siObjectColorSprite *CreateColorSprite( int iElemID )
	{
		return evc_new tsObjectColorSprite();
	}

};

#endif // INCLUDE_TSIOMANAGER_H
