#ifndef INCLUDE_TSOBJECT_H
#define INCLUDE_TSOBJECT_H
#include <windows.h>
#include "evc/IO/siObject.h"

using namespace glb;
using namespace evc;

// `̃foCXReLXg擾
HDC PaintDC();


// J[XvCg`Ǘ
class tsObjectColorSprite : public siObjectColorSprite
{
private:
	glbVector2 asPos[ 4 ];

public:
	// RXgN^
	tsObjectColorSprite()
	{
		::ZeroMemory( asPos, sizeof(glbVector2) * 4 );
	}

	// TCYXVꂽ
	virtual void UpdateSize( const glbVector2 *pSize )
	{
		this->asPos[ 1 ].X = this->asPos[ 2 ].X = pSize->X;
		this->asPos[ 2 ].Y = this->asPos[ 3 ].Y = pSize->Y;
	}

	// `v
	virtual void Draw( int iElemID, const IGLMatrix *pmParent, const glbColor *pColor )
	{
		HDC hPaintDC = PaintDC();

		POINT asPolyPoint[ 4 ];
		for( int i = 0; i < 4; i++ )
		{
			glbVector2 sRet = pmParent->TransformCoordinate( &this->asPos[ i ] );
			asPolyPoint[ i ].x = (LONG)sRet.X;
			asPolyPoint[ i ].y = (LONG)sRet.Y;
		}

		// `p̃uVƃy쐬
		COLORREF dwColor = RGB(pColor->R, pColor->G, pColor->B);
		HGDIOBJ hBrush = CreateSolidBrush( dwColor );
		HGDIOBJ hPen = CreatePen(PS_SOLID, 1, dwColor );
		HGDIOBJ hOldBrush = SelectObject( hPaintDC, hBrush );
		HGDIOBJ hOldPen = SelectObject( hPaintDC, hPen );
		// p``
		::Polygon( hPaintDC, asPolyPoint, 4 );
		// uVƃyɖ߂
		SelectObject( hPaintDC, hOldBrush );
		SelectObject( hPaintDC, hOldPen );
		DeleteObject(hBrush);
		DeleteObject(hPen);
	}
};

#endif // INCLUDE_TSOBJECT_H