#include "glbPch.h"
#include "glb/glbDefine.h"
#include "FpAnimLiner.h"
#include "../FePointInfo.h"
#include "evc/common/seMath.h"

using namespace glb;
namespace evc
{

	float FpAnimLiner::GetFramePos(float fAnimFrame, 
								const FePointInfo *pBefoInfo, 
								const FePointInfo *pNowInfo )
	{
		float fBfoRate = pBefoInfo->Rate();
		float fRate = (fAnimFrame - fBfoRate) / (pNowInfo->Rate() - fBfoRate);
	
		float fBfoValue = pBefoInfo->Value();
		return (pNowInfo->Value() - fBfoValue) * fRate + fBfoValue;
	}


	void FpAnimLiner::Load(IseStateInput *pInput)
	{
	}
}
