#include "glbPch.h"
#include "FpAnimPoint.h"

using namespace glb;
namespace evc
{

	float FpAnimPoint::GetFramePos(float fAnimFrame, const FePointInfo *pBefoInfo, const FePointInfo *pNowInfo)
	{
		float fBfoRate = pBefoInfo->Rate();
		float fRate = (fAnimFrame - fBfoRate) / (pNowInfo->Rate() - fBfoRate);
	
		return fRate >= 1.0f ? pNowInfo->Value() : pBefoInfo->Value();
	}


	void FpAnimPoint::Load(IseStateInput *pInput)
	{
	}
}
