/**
 * @file FePointInfo.h
 * @brief Aj[VԁFP_Ǘ
 *
 * @author seri
 */
#ifndef FEPOINTINFO_H
#define FEPOINTINFO_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbVector.h"

using namespace glb;

namespace evc
{
	// P_Ǘ܂B
	// 

	class FePointInfo;
	class IseStateInput;

	// Aj[V^Cv
	struct FeAnim
	{
		enum FeAnimType
		{
			Non = 0, // Ȃ
			Liner, // `
			Point, // _
			Hermite, // G~[gȐ
			Saw, // ̂

		};
		// ől
		static int EnumMax() { return (int)Saw; }
	};

	// ԃAj[Vx[X
	class IFeAnimBase
	{
	public:
		// t[(0.0f`1.0f)ɑ΂isx擾
		virtual float GetFramePos(float fAnimFrame,
								const FePointInfo *pBefoInfo, 
								const FePointInfo *pNowInfo ) = 0;

		// [h
		virtual void Load(IseStateInput *pInput) = 0;
	};


	// PҏW_Ǘ(Đp)
	class FePointInfo
	{
	private:
		// ÕL[獡̃L[܂ł0.0f`1.0fƂoߎ
		float fRate;
		float fValue;
		// ԃ^Cvʏ擾Eݒ
		IFeAnimBase *pAnimFunc;

	public:

		float Rate() const		{ return this->fRate; }
		void Rate(float value)	{ this->fRate = value; }

		float Value() const		{ return this->fValue; }
		void Value(float value)	{ this->fValue = value; }

		IFeAnimBase *AnimFunc();

		// Aj[V쐬
		void CreateAnimFunc(FeAnim::FeAnimType eAnimType);

		// RXgN^
		FePointInfo();
		FePointInfo(float fInRate, float fInValue);
		// RXgN^F[hp
		FePointInfo(IseStateInput *pInput);
		virtual ~FePointInfo();


		// 
		void Load(IseStateInput *pInput);

		// Öʒuƌo߃t[獡̈ʒu擾
		float GetPos(float fFrame, FePointInfo *pBfoInfo);


		// ̃t[̈ʒu擾
		static float GetPos(float fFrame, const est::vector<FePointInfo*> &lisPoint);
	};
}
#endif //FEPOINTINFO_H

