/**
 * @file siEventIO.h
 * @brief 
 *
 * @author seri
 */
#ifndef INCLUDE_SIEVENTIO_H
#define INCLUDE_SIEVENTIO_H
#include "glb/glbVector.h"

namespace evc
{
	/** {^
	 */
	struct ButtonType
	{
		enum Type
		{
			Non		= 0,
			Button1 = 1,
			Button2 = 1 << 1,
			Button3 = 1 << 2,
			Button4 = 1 << 3,
			Button5 = 1 << 4,
			Button6 = 1 << 5,
			Button7 = 1 << 6,
			Button8 = 1 << 7,
			Button9 = 1 << 8,
			Button10 = 1 << 9,
			Button11 = 1 << 10,
			Button12 = 1 << 11,
			Button13 = 1 << 12,
			Button14 = 1 << 13,
			Button15 = 1 << 14,
			Button16 = 1 << 15,
			Button17 = 1 << 16,
			Button18 = 1 << 17,
			Button19 = 1 << 18,
			Button20 = 1 << 19,
			Button21 = 1 << 20,
			Button22 = 1 << 21,
			Button23 = 1 << 22,
			Button24 = 1 << 23,
			Button25 = 1 << 24,
			Button26 = 1 << 25,
			Button27 = 1 << 26,
			Button28 = 1 << 27,
			Button29 = 1 << 28,
			Button30 = 1 << 29,
			Button31 = 1 << 30,
			Button32 = 1 << 31,
		};
	};

	/** Cxgpo͊ǗC^tF[X
	 * @brief {^|C^̓͏ÃNXʂĒʒmĉB
	 * ɃCxg͔̓ŌĂяo܂B
	 */
	class siEventIO
	{
	public:
		/** 
		 * @brief ͏Ԃ̍XV
		 */
		virtual void Update() = 0;

		/** 
		 * @brief ݉Ă{^擾
		 * @return ݉Ă{^orZʂ
		 * Ԃĉ
		 */
		virtual ButtonType::Type PushButton() = 0;

		/** 
		 * @brief |C^̈ʒu擾
		 * @return ݂̃|C^̈ʒu
		 */
		virtual const glb::glbVector2 *Pointer() = 0;

		/** 
		 * @brief |C^ۂ擾
		 * @return OUpdate獡Update܂łɃ|C^̈ʒuړȂ
		 * trueAړȂȂfalseԂĉB
		 */
		virtual bool IsMovePointer() = 0;
	};
}
#endif // INCLUDE_SIEVENTIO_H
