/**
 * @file siObjectFont.h
 * @brief `Ǘ
 *
 * @author seri
 */
#ifndef INCLUDE_SIOBJECTFONT_H
#define INCLUDE_SIOBJECTFONT_H
#include "glb/glbVector.h"
#include "glb/glbColor.h"
#include "glb/glbString.h"
#include "glb/IGLMatrix.h"


using namespace glb;
namespace evc
{
	// tHgX^C
	struct seFontStyle
	{
		enum Type
		{
			Regular = 0,
			Bold = 1,
			Italic = 2,
		};
	};


	/** PǗ
	 * @brief siObjectFont::CreateCharĂ΂܂B
	 * P̉摜f[^ǗĉB
	 */
	class siObjectFontChar
	{
	public:
		/** 
		 * @brief fXgN^
		 */
		virtual ~siObjectFontChar(){}

		/** TCY擾
		 * @brief ǗĂ镶̕ƍԂĉB
		 * @return ̃TCY
		 */
		virtual const glbVector2 *Size() const = 0;

		/** `
		 * @brief ێĂ镶Ɉ̕ό`}gNXAJ[Kĕ`悵ĉB
		 * @param iElemID GgID
		 * @param pmParent ό`}gNX
		 * @param pColor J[
		 */
		virtual void Draw(int iElemID, const IGLMatrix *pmParent, const glbColor *pColor ) = 0;
	};

	/** 
	 * @brief \Ǘ
	 */
	class siObjectFont
	{
	public:

		/** tHgX^C쐬
		 * @brief \ɎgtHgX^Cʒm܂B
		 * @param strFontName tHgt@~[w肳܂
		 * @param fHeight tHg̍w肳܂B
		 * @param eStyle tHg̃X^Cw肳܂BseFontStyleQƂĉB
		 * @return X^CID
		 */
		virtual int CreateFontStyle( const glb::glbString *strFontName, float fHeight, seFontStyle::Type eStyle ) = 0;

		/** NX̍쐬Jn錾
		 * @brief CreateCharĂ΂OɂPxĂ΂܂B
		 */
		virtual void BeginCharCreating() = 0;

		/** o^
		 * @brief `ɎgX^CƕĂ΂܂B͎ޕĂ΂܂B
		 * F""Ƃf[^\ꍇA'','',''w肵
		 * CreateCharꂼĂ΂A߂lsiObjectFontCharĂ΂ʂɕ`悵܂B
		 * AAiFontStyleႤƕʕƔ肳܂B
		 * F""Ƃ̂APڂƂQڂ̃tHgX^CIDႤꍇ
		 * CreateChar͂ꂼ""ɑ΂ČĂ΂܂B
		 * @param iFontStyleID siObjectFont::CreateFontStyleŎOɍ쐬ꂽX^CID
		 * @param eFormat R[h
		 * @param sChar ꕶ
		 * @return ꕶǗNX
		 */
		virtual siObjectFontChar *CreateChar(int iFontStyleID, seTextFormat::Type eFormat, short sChar ) = 0;

		/** NX̍쐬I錾
		 * @brief CreateChar̓o^IɌĂ΂܂B
		 */
		virtual void EndCharCreating() = 0;

		/** 
		 * @brief f[^Sč폜
		 */
		virtual void Clear() = 0;

		/** 
		 * @brief fXgN^
		 */
		virtual ~siObjectFont(){}
	};


}
#endif // INCLUDE_SIOBJECTFONT_H
