/**
 * @file seMatrixWork.h
 * @brief }gNX[N
 * pɂɎgꎞIMatrix͖new؂Ďgp܂B
 * @author seri
 */
#ifndef SEMATRIXWORK_H
#define SEMATRIXWORK_H
#include "glb/glbDefine.h"
#include "glb/SingletonCtrl.h"


using namespace glb;

namespace evc
{
	/** 
	 * @brief }gNX[N擾C^tF[X
	 */
	class IUseWorkMatrix
	{
	public:
		/** 
		 * @brief }gNX[N擾
		 * @return ꎞ}gNX
		 */
		virtual glb::IGLMatrix *GetMatrix() = 0;
	};

    /** 
     * @brief }gNX[N
     */
	class seMatrixWork : public IUseWorkMatrix
					   , public seSingleton
	{
	public:
		/** 
		 * @brief VOg
		 * @return 
		 */
		GLB_SINGLETON( seMatrixWork );

	private:
		static const int MaxMatrix = 16; // }gNX
		est::vector<glb::IGLMatrix *> stvWorkMatrix;
		int iStackNum; // gp}gNX
		IGLMatrix *_identity;	// Pʃ}gNX

		/** 
		 * @brief RXgN^
		 */
		seMatrixWork();
		/** 
		 * @brief fXgN^
		 */
		virtual ~seMatrixWork();
	public:

		// Pʃ}gNXԂ
		const IGLMatrix *Identity() const {  return this->_identity; }

		/** 
		 * @brief Cӂ͈͓̔Ń}gNX[N̎gpJn邱Ƃ錾
		 * @return 
		 */
		int StartMatrix();

		/** 
		 * @brief Cӂ͈͓̔Ń}gNX[N̎gpI
		 * @param iStackHandle
		 * @return 
		 */
		int EndMatrix(int iStackHandle);

		/** 
		 * @brief L}gNX擾:(\bhŊMatrixɑ΂Ďgp)
		 * ̃O[oϐȂ̂ő̃\bhŎgpĂ邩ӂKvB
		 * {IɍœK̕KvƂɂ̂ݎgB
		 * @return ꎞ}gNX
		 */
		virtual glb::IGLMatrix *GetMatrix();

		/** 
		 * @brief }gNX[NĝɍsOAIbv
		 * @param pCallback }gNX[Ngp鏈
		 */
		void UseMatrixWork( deAction1<IUseWorkMatrix *> *pCallback );

	};


	/** 
	 * @brief }gNX[NSɎgNX
	 * ꎞ}gNX̎gpJnƏIbv
	 * ̃NXĂԁASɃ}gNXgp邱Ƃł܂B
	 * evc_new ł̃NXƌǃmۂ
	 * {]|\܂B
	 */
	class seUseWorkMatrix : public IUseWorkMatrix
	{
	private:
		int		iMatrixID;
	public:
		/** 
		 * @brief RXgN^
		 */
		seUseWorkMatrix()
		{
			this->iMatrixID = seMatrixWork::Instance().StartMatrix();
		}

		/** 
		 * @brief fXgN^
		 */
		virtual ~seUseWorkMatrix()
		{
			seMatrixWork::Instance().EndMatrix( this->iMatrixID );
		}

		/** 
		 * @brief }gNX擾
		 * @return 
		 */
		virtual glb::IGLMatrix *GetMatrix()
		{
			return seMatrixWork::Instance().GetMatrix();
		}
	};


}
#endif //SEMATRIXWORK_H

