/**
 * @file seStringPair.h
 * @brief 
 *
 * @author seri
 */
#ifndef SESTRINGPAIR_H
#define SESTRINGPAIR_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbString.h"


using namespace glb;

namespace evc
{
	class IseStateInput;

	// ΕǗ
	// QPgƂĕۑ܂B
	// L[f[^΂ɂȂf[^KvɂȂ悤ȁA
	// L[[hւA{^ȂǂɎgp܂B
	class seStringPair
	{
	private:
		est::map<glbString *, glbString *> dicStringPair;

	public:
		seStringPair(){}
		virtual ~seStringPair();

		// L[f[^擾
		const glbString *GetString( const glbString * pKey );

		// yAXg擾
		const est::map<glbString*,glbString*> *Pairs() const { return &this->dicStringPair; }

		// f[^NA
		virtual void Clear();

		// f[^Pݒ
		void Add( const glbString *pKey, const glbString *pData );

		void Load( IseStateInput *pInput );
	};
}
#endif //SESTRINGPAIR_H

