/**
 * @file evCmdFlowCall.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVCMDFLOWCALL_H
#define EVCMDFLOWCALL_H
#pragma once
#include "evc/common/seIDManager.h"
#include "evCmdBase.h"

namespace evc
{
	class evCallInfo;
	class IevCmdUI;
	class IseStateInput;

	// Tu[`Ăяo
	class evCmdFlowCall : public evCmdHeader
	{
	private:
		evCallInfo *pCallInfo;

	public:
		evCmdFlowCall(){}
		evCmdFlowCall( evCmdFlowCall *pCmdCall );

		evCallInfo *CallInfo()				{ return this->pCallInfo; }
		void CallInfo( evCallInfo *value )	{ this->pCallInfo = value; }

		// ߃^Cv擾
		virtual evCmdType::Type Type() { return evCmdType::Call; }


		// Tu[`s
		virtual bool DoFunc(IevCmdUI *pCmdUI);

		virtual void Load(IseStateInput *pReader, IevCmdUI *pCmdUI);

		// N[
		virtual evCmdHeader *Clone();
	};


	// Tu[`Ǘ
	class evCallInfo
	{
	private:
		evCmdFlowIf *pFlowIf;

	public:
		evCallInfo();
		virtual ~evCallInfo();

		evCmdFlowIf *FlowIf() { return this->pFlowIf; }
	};


	// Tu[`Xg
	class evCmdFlowCallManager : public seIDManager<evCallInfo*>
	{
	public:
		void Load(IseStateInput *pReader, IevCmdUI *pCmdUI);
	};

}
#endif //EVCMDFLOWCALL_H

