/**
 * @file evDefine.h
 * @brief 
 *
 * @author seri
 */
#ifndef EVDEFINE_H
#define EVDEFINE_H
#pragma once

namespace evc
{

	// Cxg
	struct evCond
	{
		enum Type
		{
			Non = 0,					// Ȃ
			// ȉACxgN
			InTopRect,			// őOʂŃqbgۂ
			InRect,				// |C^`ɓ
			OutRect,			// |C^`Oɏo
			HitRect,			// `mڐG(ɋ`肷́Bj
			InRectPoint,		// ̍Wɓ
			OutRectPoint,		// ̍Wo
			IsState,			// ̍Wo
			IsNotState,			// ̍Wo

			ComparisonValue,	// r(lAGgXe[^XAL[Xe[^XAlϐA[U[R[)

			IsPush,				// {^ꂽȂ
			IsFirstPush,		// {^߂ĉꂽȂ
			IsPop,				// {^ĂȂ
			IsStartAnim,		// Aj[VJnȂ
			MovePoint,			// }EXړȂ

			// 
			Comment,			// Rg
		};

		static int EnumMax() { return Comment; }
	};


	// ȉAsCxg
	struct evEvent
	{
		enum Type
		{
			AnimPlay,		// Aj[VĐ
			AnimPause,		// Aj[Vꎞ~
			AnimContinue,	// Aj[VĊJ
			AnimJump,		// Aj[Vt[ړ

			SceneAnim,		// V[Aj[VĂяo(V[Gg̏ꍇ̂)

			InputPause,		// ͈ꎞ~
			InputContinue,	// ͍ĊJ
			SetStatus,		// Xe[^Xݒ
			RemoveStatus,	// Xe[^X폜
			ClearStatus,	// Xe[^XNA
			
			OperatorValue,	// Z(lAGgXe[^XAL[Xe[^XAlϐ֒l̎)

			// fobO֌W
			DebugString,	// fobO\
			DbWriteNum,		// ϐo

			// 
			Comment,			// Rg
		};
		
		static int EnumMax() { return Comment; }
	};


	// f[^^Cv
	struct evDataType
	{
		enum Type
		{
			Non, // O

			// intP̃f[^
			Int, // l
			AnimID, // Aj[VID
			// Valueݒ莞seElemXVNXɂH
			Elem, // Gg
			Button, // {^

			UserCall, // [U[Ăяo


			// P̃f[^
			String, // 
			DebugMsg, // fobObZ[W

			// |C^ʒuێf[^
			ElemState, // GgXe[^X
			KeyName, // L[+Index
			VariableState,
			VariableStateItem,
			VariableNum,
		};
		static int EnumMax() { return VariableNum; }
	};

	// CxgZq
	struct evOperator
	{
		enum Type
		{
			Non, // 

			// Cxgp
			Add, // += Z
			Sub, // -= Z
			Set, //  
			Mul, // *= Z
			Div, // /= Z
			Quotient,	// %= ]

			// p
			Over, // > 傫
			Under, // < 
			Same, // == 
			Diff, // != Ⴄ
			SameOrOver, // >= ȏ
			SameOrUnder, // <= ȉ
		};
		static int EnumMax() { return SameOrUnder; }
	};


}
#endif //EVDEFINE_H

