#include "glbPch.h"
#include "glb/glbString.h"
#include "seKeyControlManager.h"
#include "evc/seElem/seElemAnim/seStateKeyInfo.h"

using namespace glb;
namespace evc
{

	int seKeyControlManager::Add(seStateKeyInfo *tData)
	{
		// ȖOo^ꂽȂ
		if ((tData->Name() == null) || 
			(tData->Name()->IsEmpty()) )
		{
			// Xg폜
			int iID = this->seIDManager<seStateKeyInfo*>::Find( tData );
			this->Remove( iID );
			return seKeyControlManager::InvalidID;
		}
	
		return this->Add( tData);
	}

	// NA
	void seKeyControlManager::Clear()
	{
		this->DeleteAllInstance();
		this->seIDManager<seStateKeyInfo*>::Clear();	
	}

	seStateKeyInfo *seKeyControlManager::Find( const glbString *pName)
	{
		if ( pName == null ) return null;

		const est::map<int,seStateKeyInfo*> &keys = *this->Piars();
		est::map<int,seStateKeyInfo*>::const_iterator it = keys.begin();
		while(it != keys.end())
		{
			if (*pName == *it->second->Name())
				return it->second;
			it ++;
		}
		return null;
	}
}
