/**
 * @file seObjectManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOBJECTMANAGER_H
#define SEOBJECTMANAGER_H
#pragma once
#include "evc/common/seIDManager.h"
#include "seSceneManager.h"


using namespace glb;
namespace evc
{
	class seSceneManager;
	class IseStateInput;
	class seObject;

	/**
	 * \IuWFNgǗNX
	 */
	class seObjectManager : public seIDManager<seObject*>
	{
	private:
		static const int OBJECT_BASE_ID = 6000; // x[XIuWFNghc

		seSceneManager *pSceneManager;

	public:
		// RXgN^
		seObjectManager( seSceneManager *pSceneManager );
		virtual ~seObjectManager();

		// NA
		virtual void Clear();

		virtual int Add(seObject *tData);

		// IDw肵ăIuWFNgǉ鎞
		virtual void Add(int iNewObjectID, seObject *pNewObject);

		// [h
		void Load(IseStateInput *pInput);

	};

}
#endif //SEOBJECTMANAGER_H
