/**
 * @file seOption.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEOPTION_H
#define SEOPTION_H
#pragma once
#include "glb/glbString.h"
#include "glb/glbColor.h"
#include "glb/glbVector.h"

using namespace glb;

namespace evc
{
	class IseStateInput;

	// pXݒ
	struct seOutputPath
	{
		enum Type
		{
			Non, // pXȂ(t@Ĉ)
			Global, // ΃pX
			Local, // ΃pX
		};
		static int EnumMax() { return Local; }
	};


	// t@CʃIvVǗ
	class seOption
	{
	private:
		glbColor			sBgColor;
		int					iFrameNum;
		glbVector2			sScreenSize;
		float				fFrameTime; // Pt[b
		seOutputPath::Type	ePathMode;
		bool				bAddExt;
		bool				bNoDebugData;
		bool				bCopyFile;
		bool				bIncludeElemName;
		bool				bIncludeKeyWord;
		seTextFormat::Type	eTextFormat; // o͕tH[}bg
		seTextFormat::Type	eInsideName; // tH[}bg

	public:
		// wiF̎擾Eݒ
		const glbColor *BgColor() const { return &this->sBgColor; }
		void BgColor( const glbColor *value ) { this->sBgColor = *value; }

		// t[̎擾Eݒ
		int FrameNum() const	 { return this->iFrameNum; }
		void FrameNum(int value) { this->iFrameNum = value; }

		// XN[TCY̎擾Eݒ
		const glbVector2 *ScreenSize() const	 { return &this->sScreenSize; }
		void ScreenSize(const glbVector2 *value) { this->sScreenSize = *value; }

		// Pt[̕b擾Eݒ
		float FrameTime() const		{ return this->fFrameTime; }
		void FrameTime(float value) { this->fFrameTime = value; }

		// pXo̓[h
		seOutputPath::Type PathMode() const		{ return this->ePathMode; }
		void PathMode(seOutputPath::Type value) { this->ePathMode = value; }

		// gqo
		bool AddExt()			{ return this->bAddExt; }
		void AddExt(bool value) { this->bAddExt = value; }

		// fobOf[^o͂Ȃ
		bool NoDebugData() const	{ return this->bNoDebugData; }
		void NoDebugData(bool value){ this->bNoDebugData = value; }

		// gpt@CRs[
		bool CopyFile() const		{ return this->bCopyFile; }
		void CopyFile(bool value)	{ this->bCopyFile = value; }

		// Ggf[^Ɏ
		bool IncludeElemName() const	{ return this->bIncludeElemName; }
		void IncludeElemName(bool value){ this->bIncludeElemName = value; }

		// L[[hf[^Ɏ
		bool IncludeKeyWord() const		{ return this->bIncludeKeyWord; }
		void IncludeKeyWord(bool value) { this->bIncludeKeyWord = value; }

		// eLXgtH[}bg
		seTextFormat::Type MsgFormat() const		{ return this->eTextFormat; }
		void MsgFormat(seTextFormat::Type value)	{ this->eTextFormat = value; }

		// (\[XAAj[V)tH[}bg
		seTextFormat::Type InsideName() const		{ return this->eInsideName; }
		void InsideName(seTextFormat::Type value) { this->eInsideName = value; }

		// RXgN^
		seOption();

		// NA:lɖ߂
		void Clear();

		// 
		void Load(IseStateInput *pInput);

	};
}
#endif //SEOPTION_H

