/**
 * @file seStateKeyManager.h
 * @brief 
 *
 * @author seri
 */
#ifndef SESTATEKEYMANAGER_H
#define SESTATEKEYMANAGER_H
#pragma once
#include "glb/glbDefine.h"
#include "evc/common/seDefine.h"

using namespace glb;
namespace evc
{
	class seStateKeyInfo;
	class IseStateInput;
	class seSceneManager;

	// Aj[VL[Ǘ
	class seStateKeyManager
	{
	private:
		static const int InvalidKey = -1;

		emElemState::Type eStateType;
		est::vector<seStateKeyInfo*> liKeyList;

	public:
		// f[^^Cv擾
		emElemState::Type StateType() const { return this->eStateType; }

		// QƗpL[Xg
		const est::vector<seStateKeyInfo*> &Keys() const { return this->liKeyList; }

		// RXgN^
		seStateKeyManager( emElemState::Type eStateType );
		virtual ~seStateKeyManager();


		// L[t[̍폜
		void Clear();

		// 
		void Load(IseStateInput *pInput, seSceneManager *pSceneManager);
	};
}
#endif //SESTATEKEYMANAGER_H

