#include "glbPch.h"
#include "seStateJump.h"
#include "glb/glbDebug.h"

namespace evc
{
	seStateKeyJumpStack::seStateKeyJumpStack(seStateKeyInfo *pKey, int iLoopNum)
	{
		this->pKey = pKey;
		this->iLoopNum = iLoopNum;
	}


	// seStateJump
	//

	// fXgN^
	seStateJump::~seStateJump()
	{
		this->Clear();
	}

	void seStateJump::Clear()
	{
		while( !this->stkJump.empty() )
		{
			this->Pop();
		}
	}

	void seStateJump::Pop()
	{
		seStateKeyJumpStack *pKey = this->stkJump.top();
		delete pKey;
		this->stkJump.pop();
	}

	bool seStateJump::AddStack(seStateKeyInfo *pKey)
	{
		if ( !this->stkJump.empty() )
		{
			seStateKeyJumpStack *pStack = this->stkJump.top();
			// ɓo^ĂȂ烋[v痈̂ōēo^ȂB
			if ( pStack->pKey == pKey ) return false;
		}

		this->stkJump.push( evc_new seStateKeyJumpStack(pKey, 0) );
		return true;
	}


	seStateKeyJumpStack *seStateJump::IncLoopNum()
	{
		if ( this->stkJump.empty() )
		{
			GLB_DB_STRING( "Key Error : Ή郋[v܂łB\n" );
			return null;
		}
	
		seStateKeyJumpStack *pStack = this->stkJump.top();
		pStack->iLoopNum ++;
		return pStack;
	}
}
