/**
 * @file seStateJump.h
 * @brief 
 *
 * @author seri
 */
#ifndef INCLUDE_SESTATEJUMP_H
#define INCLUDE_SESTATEJUMP_H
#include "glb/glbDefine.h"


namespace evc
{
	class seStateKeyInfo;

	/** L[t[pWvX^bN
	 * @brief 
	 */
	class seStateKeyJumpStack
	{
	public:
		seStateKeyInfo *pKey;
		int iLoopNum;

		/** 
		 * @brief RXgN^
		 * @param pKey
		 * @param iLoopNum
		 */
		seStateKeyJumpStack(seStateKeyInfo *pKey, int iLoopNum);
	};

	/** WvX^bNǗ(Ƀ[vp)
	 * @brief 
	 */
	class seStateJump
	{
	private:
		// WvX^bNXg(Ƀ[vp)
		est::stack<seStateKeyJumpStack*> stkJump;

	public:
		/** 
		 * @brief fXgN^
		 */
		virtual ~seStateJump();

		/** f[^NA
		 * @brief 
		 */
		void Clear();

		/** 擪폜
		 * @brief 
		 */
		void Pop();

		/** X^bNǉ
		 * @brief 
		 * @param pKey
		 * @return true:ǉ@false:ǉȂ(ɓo^ς)
		 */
		bool AddStack(seStateKeyInfo *pKey);

		/** 擪̃X^bNɃ[vǉ
		 * @brief 
		 * @return 
		 */
		seStateKeyJumpStack *IncLoopNum();
	};
}
#endif // INCLUDE_SESTATEJUMP_H
