/**
 * @file seFontPage.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEFONTPAGE_H
#define SEFONTPAGE_H
#pragma once
#include "glb/glbDefine.h"
#include "glb/glbVector.h"
#include "seFontChar.h"

using namespace glb;
namespace evc
{
	class seFontLine;
	class seFontChar;

	// Py[W
	// bZ[W
	class seFontPage
	{
	private:
		est::vector<seFontLine*> lisLine;
		glbVector2 sSize; // TCY

	public:
		const est::vector<seFontLine*> *Lines() const { return &this->lisLine; }

		// `̈TCY擾
		const glbVector2 *Size() const { return &this->sSize; }

		// RXgN^
		seFontPage();
		virtual ~seFontPage();


		// o^֌W

		// Ō̍s擾
		seFontLine *GetLastLine();

		// Vs쐬
		void Add(seFontLine *pLine);

		// ڂ̏擾
		seFontChar *GetCharInfo(int iTextNum);



		// f[^NA
		void Clear();


		// Py[W̕`TCY擾
		void UpdateSize();

		// Py[W`
		void Draw(int iElemID, 
				const IGLMatrix *mParent, 
				const glbColor *sColor, 
				int iDrawNum);

	};

}
#endif //SEFONTPAGE_H

