/**
 * @file seoNum.h
 * @brief 
 *
 * @author seri
 */
#ifndef SEONUM_H
#define SEONUM_H
#pragma once
#include "glb/glbColor.h"
#include "glb/glbVector.h"
#include "evc/common/seDefine.h"
#include "evc/seObject/seObject.h"
#include "evc/seObject/seObjectWork.h"

using namespace glb;
namespace evc
{
	class seElem;
	class seoNum;
	class seStateInt1;
	class seStateNumInfo;
	class IseStateInput;
	class seSceneManager;

	// l`Ǘ
	// ̃eNX`IuWFNg(0`9,J}A}CiX)܂Ƃ߂
	// l\

	class seoNumWork : public seObjectWork
	{
	private:
		seElem *pElem;
		seoNum *pObject;
		// gXe[^X
		seStateInt1 *pNum;
		seStateNumInfo *pNumInfo;

		glbVector2 sSize;
	public:
		virtual seObject *Object();

		// RXgN^
		seoNumWork(seElem *pInElem, seoNum *pInObjct);
		virtual ~seoNumWork();

		// `
		virtual void Draw();

		// XV
		virtual void Update(float fAddTime);

		// IuWFNg̃TCY擾
		virtual const glbVector2 *GetSize();

	};




	// J[`
	class seoNum : public seObject
	{
	private:
		// C[WǗFObjectIDݒ肵ĂƁAKvȎɃeNX`IuWFNgԂ܂
		// [hAID擾ɃIuWFNg݂Ȃꍇ̒xB
		class seoNumTexture
		{
		private:
			seObject *pParent;
			seoTextureSprite *pImage;
			int iID;

		public:
			// C[W擾
			seoTextureSprite *Image();
			void Image(seoTextureSprite *value);

			int ID() const { return this->iID; }
			void ID(int value);

			seObject *Parent() { return this->pParent; }
			void Parent( seObject *pObj ) { this->pParent = pObj; }

			// RXgN^
			seoNumTexture();
		};


		// \[N
		est::vector<seoTextureSprite *> vecImageWork;
		est::vector<float> vecImageWidth; 
		// C[WXg
		est::vector<seoNumTexture> apImageList;
		float fHeight;		// 
		glbColor sColor;	// J[

	public:
		seoNum();
		virtual ~seoNum();

		const glbColor *Color() const { return &this->sColor; }
		void Color( const glbColor *value) { this->sColor = *value; }

		float Height() const { return this->fHeight; }

		// `IuWFNg^Cv
		virtual emObject::Type ElemType() const { return emObject::Num; }

		// C[Wݒ
		void SetImage(seoNumImage::Type eImageType, seoTextureSprite *pObject);

		// C[W擾
		seoTextureSprite *GetImage(seoNumImage::Type eImageType);


		// `掞ɕKvȃ[NNX쐬
		virtual seObjectWork *CreateDrawWork(seElem *pElem);


		// `
		void Draw( int iElemID, 
				   const IGLMatrix *mParent, 
				   const glbColor *sMulColor, 
				   int iNum, 
				   seStateNumInfo *pNumInfo );

		// \lf[^
		// @retval : \l
		void SetNumInfo(int iNum, seStateNumInfo *pNumInfo, deAction1<seoNumImage::Type> *pFunc );

		// ݒς݂ainFontList當擾
		float GetNumWidth(int iNum, seStateNumInfo *pNumInfo);

		// [h
		virtual void Load(IseStateInput *pInput, seSceneManager *pManager);

	};


}
#endif //SEONUM_H

