/**
 * @file seResourceScene.h
 * @brief 
 *
 * @author seri
 */
#ifndef SERESOURCESCENE_H
#define SERESOURCESCENE_H
#pragma once
#include "evc/common/seDefine.h"
#include "evc/IO/siResource.h"
#include "glb/glbDefine.h"

using namespace glb;
namespace glb
{
	class glbString;
}

namespace evc
{
	class seSceneManager;
	class siResourceBase;


	// eNX`C[WǗ
	class seResourceScene : public siResourceBase
	{
	private:
		seSceneManager *pScene;

	public:
		// V[擾
		seSceneManager *Scene() const { return this->pScene; }

		// RXgN^(V[Rs[)
		seResourceScene( const glbString *strFileName, seSceneManager *pScene);
		// RXgN^(oCit@C[h)
		seResourceScene( const glbString *strFileName);

		virtual ~seResourceScene();


		// \[X^Cv
		virtual emResourceState::Type Type() const {return emResourceState::Scene;}

		// V[
		virtual siResourceInit::Type Init(const est::vector<glb::Byte> *buffer);

		// ݂̃V[gp\ۂ
		bool IsEnableScene();

		// V[nB
		// nV[͂̃NXł͊ǗȂȂ܂B
		// seResourceSceneDisposeĂV[ێĂɎgpĉB
		seSceneManager *PassesScene();


	private:
		// ǂݍ݂郊\[Xɑ΂Ă̂ݏs
		void DoFirstLoadAll( deAction1<siResourceBase*> *pFunc);
	};
}
#endif //SERESOURCESCENE_H

