/**
 * @file glbString.h
 * @brief ǗNX
 * R[hHÂ܂܂̒lŊǗ܂B
 * @author seri
 */
#ifndef GLBSTRING_H
#define GLBSTRING_H
#include "glbDefine.h"

// UTF16pL^
typedef const short GLB_UNICODE;

namespace glb
{
	// tH[}bg^Cv
	struct seTextFormat
	{
		enum Type
		{
			Utf16 = 0,
			Shift_Jis,
		};

		static int EnumMax() { return Shift_Jis; }
	};

	// pǗNX
	class glbString
	{
	private:
		seTextFormat::Type	eFormat;
		est::vector<unsigned char> stvBuffer;

	public:
		// tH[}bg擾
		seTextFormat::Type Format() const	{ return this->eFormat; }

		const est::vector<unsigned char> &Buffer() const { return this->stvBuffer; }

		// 񂩔ۂ
		bool IsEmpty() const { return this->stvBuffer.empty(); }

		glbString() : eFormat(seTextFormat::Shift_Jis) {}

		// f[^ݒ
		glbString( seTextFormat::Type eType, const char *pBuffer, int iByteSize );
		glbString( GLB_UNICODE *pcString );
		glbString( const char *pcString );
		
		// 
		glbString *Clone() const;

		// e̔r
		bool operator == ( const glbString &str) const;
		// Rs[
		glbString& operator = ( const glbString& str);

	private:
		// IR[hǉ
		void AddEndCode();
	};
}
#endif // GLBSTRING_H
